<?php

// Enable all error reporting
// Disabled for users later
ini_set('display_errors', 1);
error_reporting(E_ALL);

// Constants
// Deprecated
if (!defined("SVN_VERSION"))
	define('SVN_VERSION', '1608');
if (!defined("RELEASE_TYPE"))
	define('RELEASE_TYPE', 'testing');
if (!defined("FRAMEWORK_VERSION"))
	define('FRAMEWORK_VERSION', '84');
if (!defined("CORE_COMPATIBILITY"))
define('CORE_COMPATIBILITY', '8');
if (!defined("br"))
define('br', PHP_EOL);
if (!defined("DROOT"))
define('DROOT', preg_replace("/[^\/]$/","$0/",$_SERVER['DOCUMENT_ROOT']));

// Shell
if (isset($_SERVER['SHELL'])) {
	$myself = isset($_SERVER['HOSTNAME']) ? "/".trim($_SERVER['PWD'],"/")."/".trim(str_replace($_SERVER['PWD'], "",$_SERVER["SCRIPT_FILENAME"]),"./"): $_SERVER["SCRIPT_FILENAME"];
	$paths =	explode("kitbooth", $myself);
	$_SERVER['DOCUMENT_ROOT'] = $paths[0];
	$_SERVER['PHP_SELF'] = "/kitbooth/core/pseudo.php";
	if (!defined("SHELL"))
		define('SHELL', true);
}

else {
	if (!defined("SHELL"))
		define('SHELL', false);
}



abstract class KB_class {

	private $config = [];
	private $private_config = [];

	private static $core;

	function __construct($core){
		self::$core = $core;
	}

	public function config($name = NULL, $value = NULL) {

		if (is_null($name) || is_empty($name))
			return $this->config;

		if (is_array($name) && !is_indexed($name)) {
			foreach ($name as $var => $value) {
				$this->config($var, $value);
			}
			return;
		}

		if (is_null($value))
			return key_of($name, $this->config);

		if (count($args = func_get_args()) < 3) {
			$this->config[$name] = $value;
		}

		else {
			$name = key_of(0,$args);
			$value = current(array_slice($args,-1));
			$keys = array_slice($args, 1, -1);
			$keys = array_reverse($keys);
			$array = $value;
			foreach ($keys as $key) {
				$array = array($key => $array);
			}
			$this->config[$name] = self::$core->array->merge(
				key_of($name,$this->config),
				$array
			);
		}

		return NULL;

	}

	protected function private_config($name = false, $value = NULL){

		if (!$name)
			return $this->private_config;

		if (is_array($name)){
			foreach($name as $var => $value){
				$this->private_config($var, $value);
			}
			return;
		}

		if ($value !== NULL) {
			$this->private_config[$name] = $value;
			return $value;
		}

		return key_fetch($name,$this->private_config);

	}

}

abstract class KB_class_extended extends KB_class {

	private $core;

	function __construct($core){
		$this->core = $core;
	}

	function __call($var = "", $set = NULL) {

		if (method_exists($this, $var))
			return NULL;

		$set = key_of(0,$set);

		if ($set === NULL)
			return $this->config($var);

		$this->config($var, $set);
		return $set;

	}


	function __get($var = "") {

		// Backwards compatibility
		if ($var === "key_value")
			$var = "key";

		return $this->config($var);
	}


	function __set($var = "", $value = "") {

		// Backwards compatibility
		if ($var === "key_value")
			$var = "key";

		$this->config($var, $value);
	}

}


class KB_core extends KB_Class {

	public $core_config = [];
	public $request_var = [];
	public $GET_options = NULL;
	public $time = array("","");
	public $magic_quotes = false;
	public $refresh = false;
	public $db = false;
	private $init = true;
	private $debug = false;
	private $core_kits;
	private static $config = NULL;

	public
		$array,
		$blog,
		$calc,
		$color,
		$config_creator,
		$content,
		$correlation,
		$csv,
		$data,
		$db_call,
		$db_call_count,
		$db_error,
		$exec,
		$file,
		$filesystem,
		$folder,
		$format,
		$fs,
		$html,
		$image,
		$install,
		$json,
		$kb_tables,
		$kit,
		$language,
		$markdown,
		$menu,
		$message,
		$msg,
		$pdf,
		$rest,
		$session,
		$statistic,
		$string,
		$structure,
		$svg,
		$tables,
		$template,
		$user,
		$video,
		$view,
		$xhtml,
		$xml,
		$zip;


	function __construct($case = "") {

		require_once "functions.php";

		if (version_compare(PHP_VERSION, '8.0.0', "<"))
			require_once "compatibility/functions.php";

		runtime();

		if (any_empty($case, is_string($case)))
			return false;

		$case = strtolower($case);

		// Globals
		// Deprecated
		if (!defined("BACKEND"))
			define("BACKEND", are_equal("backend",$case));
		if (!defined("FRONTEND"))
			define("FRONTEND", are_equal("frontend",$case));
		if (!defined("CORE"))
			define("CORE", are_equal("core",$case));

		$this->runs("backend",are_equal("backend",$case));
		$this->runs("frontend",are_equal("frontend",$case));
		$this->runs("core",are_equal("core",$case));
		$this->runs("cron",are_equal("cron",$case));

		if ($this->runs("frontend"))
			error_reporting(0);

		// Globals
		// Deprecated
		if (!defined("KB_FOLDER"))
			define('KB_FOLDER', $this->path());
		if (!defined("FRONTEND_FOLDER"))
			define('FRONTEND_FOLDER', $this->path("frontend"));
		if (!defined("CONTENT_FOLDER"))
			define('CONTENT_FOLDER', $this->path("content"));
		if (!defined("FILES_FOLDER"))
			define('FILES_FOLDER', $this->path("files"));
		if (!defined("FILES_TEMP"))
			define('FILES_TEMP', 'temp/');
		if (!defined("TPL_FOLDER"))
			define('TPL_FOLDER', $this->path("templates"));
		if (!defined("TEMPLATE_FOLDER"))
			define('TEMPLATE_FOLDER', $this->path("templates"));
		if (!defined("KITS_FOLDER"))
			define('KITS_FOLDER', $this->path("kits"));
		if (!defined("CORE_FOLDER"))
			define('CORE_FOLDER', $this->path("core"));
		if (!defined("LIB_FOLDER"))
			define('LIB_FOLDER', $this->path("library"));
		if (!defined("BACKEND_TEMPLATE"))
			define('BACKEND_TEMPLATE', $this->path("template"));

		$this->config_creator = "Core";
		$this->db_call_count = 0;
		$this->time = explode(" ", microtime());


		if (version_compare(phpversion(), '5.4', '<'))
			$this->magic_quotes = get_magic_quotes_gpc();

		// Remove Superglobals
		$this->set_vars(array("get", "post", "files", "cookie"));
		if (!defined("REST"))
			define("REST", fetch("rest",$this->get_var("lid")));
		$this->runs("rest",fetch("rest",$this->get_var("lid")));

		// Include classes which are database independent
		$this->array = $this->array_object();
		$this->string = $this->string_object();
		$this->format = $this->string->format;
		$this->json = $this->string->json;
		$this->markdown = $this->string->markdown;

		$this->csv = $this->csv_object();
		$this->session = $this->session();
		$this->session->start();

		$this->set_vars(array("session"), false);

		$this->message = $this->message();
		$this->msg =& $this->message;
		$this->data = $this->settings();
		$this->filesystem = $this->filesystem();
		$this->fs =& $this->filesystem;
		$this->calc = $this->calc();
		$this->view = $this->view();
		$this->file = $this->filesystem->file;
		$this->folder = $this->filesystem->folder;
		$this->rest = $this->rest();
		$this->html = $this->html();
		$this->xhtml = $this->xhtml();
		$this->xml = $this->xml();
		$this->svg = $this->svg();
		$this->language = $this->language();
		$this->menu = $this->menu();
		$this->pdf = $this->pdf();
		$this->image = $this->image();
		$this->video = $this->video();
		$this->zip = $this->zip();
		$this->exec = $this->exec();
		$this->color = $this->color();
		setlocale(LC_CTYPE, key_of(0,$this->language->accept()).'.utf8');

		if ($this->runs("core"))
			return;



		// Try database connection
		$this->db = $this->db();

		// Fail
		// Load template lib without database connection
		if (!$this->db){
			$this->template	= $this->template();
			return;
		}


		// Include classes which are database dependent

		$this->tables	= $this->tables();

		$this->kb_tables	=& $this->tables;
		$this->correlation = $this->correlation();
		$this->statistic	= $this->statistic();
		$this->user = $this->user();



		if ($this->user->is_dev())
			$this->db->set_dev();



		$this->install = new KB_installation($this);
		$this->install->restore_database();
		$this->install->default_config();

		//Perform user logout, if requested
		if ($this->get("logout","get")) {
			$this->user->sign_out();
			$this->refresh(["logout" => ""]);
		}

		//Perform user login, if requested
		$this->user->check($this->get('username'), $this->get('password'));

		if ($this->user->data("group_ID")) {
			$usergroups = key_fetch($this->user->group->key(),$this->user->group->children($this->user->data("group_ID")));
			$IDs = $this->array->union(array($this->user->data("group_ID")),(array) $usergroups);
			$this->user->filter(array($this->user->group() => $IDs), true);
			$this->user->group->filter(array($this->user->group->key() => $IDs), true);
		}



		if ($this->user->logged_in()) {
			$this->language->accept(
				$this->user->data("language")
			);
			setlocale(LC_CTYPE, key_of(0,$this->language->accept()).'.utf8');
		}



		// No notices for users not in dev group.
		if ($this->runs("backend") && !$this->user->is_dev())
			error_reporting(E_ALL ^ E_NOTICE);

		// No Notices and Warnings for all users not in the top group.
		if ($this->runs("frontend") && $this->user->is_dev())
			// error_reporting(E_ERROR | E_PARSE);
			error_reporting(E_ALL);



		$this->content = $this->content();
		$this->blog = $this->blog();
		$this->template	= $this->template();
		$this->kit = $this->kit();
		$this->core_kits = $this->core_kits();
		$this->init = false;

		if ($this->runs("cron"))
			return;

		$this->core_kits->run_all("core");

		// Deprecated
		$this->structure =& $this->content->group;
	}


	// Public methods

	public function config($key = false, $value = NULL){
		// Read and write additional config, database based

		if (is_empty($key))
			return false;

		if (is_null($value))
			return $this->get_core_value($key);

		return $this->write_core_data($key,$value);
	}


	public function core_config ($key = false) {

		// Core Config, file based

		// Use cache
		if (!is_null(self::$config)) {

			if (count($args = func_get_args()) > 1) {

				$config = self::$config;

				foreach ($args as $arg)
					$config = key_of($arg, $config);

				return $config;
			}

			if ($key)
				return key_fetch($key,self::$config);

			return self::$config;
		}

		// Include config file
		if (is_file($file = $this->path("root", "kitbooth")."config.json")) {
			$core_config = $this->file->read($file);
			$core_config = $this->json->decode($core_config);
		}

		// Backwards Compatibility
		else if (is_file($file = $this->path("root", "kitbooth")."config.txt")) {
			$core_config = $this->file->read_php($file, [], "core_config");
		}

		else {
			$core_config = [];
		}

		// Write cache
		self::$config = $core_config;

		// Return
		return $this->core_config($key);

	}


	public function debug($set = NULL) {

		if (is_null($set))
			return $this->debug;

		if (is_int($set))
				$this->debug = $set;

		else
			$this->debug = (bool) $set;

		return $this->debug;

	}


	public function escape_string($string) {
		return ($this->magic_quotes) ? $string : str_replace("'", "\'", $string);
	}


	public function get_var($name = "", $source = array("set","get","post","session","cookie","files")) {

		if (any_empty($name, $source))
			return NULL;

		if (are_empty(is_string($name), is_bool($name)))
			return NULL;

 		if (defined($name))
			return constant($name);

		$vars = $this->private_config("vars");

		foreach ((array) $source as $key) {

			if ($name === true && !is_null($value = key_of($key, $vars)))
				return $value;

			if (!is_null($value = key_of($name, key_of($key, $vars))))
				return $value;

		}

		return NULL;

	}


	public function kit_url($options = [], $set_absolute = true) {

		$options["kit"] = $core->get("kit", "get");
		return $this->url($options, $set_absolute);

	}


	public function path($folder = NULL) {

		if (count($args = func_get_args()) > 1) {

			$return = "";

			foreach ($args as $arg)
				$return .= $this->path($arg);

			return $return;

		}


		if (is_empty($folder))
			$folder = "kitbooth";

		$cache = $this->private_config("folders");

		if (key_of($folder, $cache) !== NULL)
			return key_of($folder, $cache);

		switch ($folder) {

			case "kitbooth":

				$paths = explode("/", dirname($_SERVER['PHP_SELF']));
				$path = "";

				foreach($paths as $value){

					if (not_empty($value))
						$path .= $value.'/';

					if ($value == 'kitbooth')
						break;
				}

				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;


			case "url":

				$kitbooth_path = $this->path();
				$path = "";

				if (strpos($_SERVER["REQUEST_URI"],$kitbooth_path) !== false)
					$path  = $kitbooth_path;

				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;


			case "root":

				$path = preg_replace("/[^\/]$/","$0/",$_SERVER['DOCUMENT_ROOT']);

				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;


			case "core":

				$path = $this->path()."core/";

				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;

			case "frontend":

				$path = $this->path()."frontend/";
				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;

			case "content":

				$path = $this->path("frontend")."content/";
				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;

			case "files":

				$path = $this->path("frontend")."files/";
				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;

			case "templates":

				$path = $this->path("frontend")."templates/";
				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;

			case "kits":

				$path = $this->path()."kits/";
				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;

			case "lib":
			case "library":

				$path = $this->path("core")."library/";
				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;

			case "template":
			case "backend_template":

				$path = $this->path("core")."template/";
				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;

			case "backup":

				$path = $this->path("")."backup/";
				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;

			case "upgrade":

				$path = $this->path("")."upgrade/";
				$cache[$folder] = $path;
				$this->private_config("folders", $cache);
				return $path;

			default:

				return NULL;


		}


	}


	public function refresh($url_options = false) {

		if ($url_options && is_array($url_options))
			$this->url_options($url_options);

		$location = $this->generate_url_decoded();

		if ($this->runs("frontend")) {
			$location = ifttt(
				are_equal($location, "?"),
				"/".$this->path("url").ifttt($this->get_var("lid"), $this->get_var("lid")."/").ifttt($this->get_var("cid"), $this->get_var("cid")),
				$location
			);
			$location = either($location, "/");
		}

		$this->refresh = true;

		if (!headers_sent()){
			header('Location: '.$location);
			exit(0);
		}
	}


	public function runs($case = "", $set = NULL) {

		$options = $this->private_config("runs");

		if (is_empty($case)) {

			foreach ($options as $key => $value)
				if ($value === true)
					return $key;

			return false;
		}

		if (!is_null($set) && $this->init === true) {
			$options[$case] = (bool) $set;
			$this->private_config("runs",$options);
		}

		if (is_indexed($cases = $case, true)) {
			foreach ($cases as $case) {

				if ($this->runs($case))
					return true;
			}
			return false;
		}


		return either(key_of($case, $options), false);

	}


	public function set_var($name = "", $value = "") {

		if (is_empty($name))
			return false;

		$vars = $this->private_config("vars");

		$vars["set"] = $this->array->merge(
			key_of("set", $vars),
			array($name => $value)
		);

		$this->private_config("vars",$vars);

		return $vars;
	}


	public function time() {
			$time = explode(" ", microtime());

			$t1 = $time[1] - $this->time[1];
			$t0 = $time[0] - $this->time[0];

			return $t0+$t1;
	}


	public function upgrade() {

		if (is_empty($files = $this->folder->read($this->path("root","upgrade"))))
			return true;

		$return = [];

		foreach ($files as $file) {

			if ($this->file->basename($file) < $this->version("release"))
				continue;

			$return[] = $this->file->read_php(
				$this->path("root","upgrade").$file
			);
		}

		return $return;

	}


	public function url($options = [], $set_absolute = false) {

		$gets = [];

		if (!$set_absolute) {

			if (empty($this->array))
				$options = array_merge($this->url_options(), $options);
			else
				$options = $this->array->merge($this->url_options(), $options);
		}

		foreach ($options as $key => $value) {

			if (is_empty($value))
				continue;

			if (is_array($value))
				$value = $this->json->decode($value);

			$gets[] = urlencode($key)."=".urlencode($value);
		}

		if (not_empty($gets))
			return "?".implode("&amp;",$gets);

		if ($this->runs("backend"))
			return "?";

		return "/".ifttt($this->get("lid"), $this->get("lid")."/").$this->get("cid");
	}


	public function url_decoded($options = [], $set_absolute = false) {
			$return = $this->generate_url($options, $set_absolute);
			$return = preg_replace("-&amp;-","&",$return);
			return $return;
	}


	public function url_options($set = false, $set_absolute = false) {

		$url_options = $this->private_config("url_options");

		if ($set) {
			$url_options = $this->array->merge($url_options, $set);
			$this->private_config("url_options",$url_options);
			return $url_options;
		}

		if (!$set_absolute)
			$url_options = $this->array->merge(
				$this->get_var(true, "get"),
				$url_options
			);

		if ($this->runs("frontend"))
			$url_options = remove_keys_of(array("cid", "lid"), $url_options);

		return $url_options;

	}


	public function value($name = false, $set = NULL) {

		// Shorthand function for get_var and set_var

		if (is_empty($name))
			return NULL;

		if (is_null($set))
			return $this->get_var($name);

		return $this->set_var($name, $set);

	}


	public function version($type = false) {

		static $version = false;

		if (!$version)
			$version = [
				"release" => SVN_VERSION,
				"compatibility" => CORE_COMPATIBILITY,
				"framework" => FRAMEWORK_VERSION,
				"channel" => RELEASE_TYPE,
			];

		if (is_string($type) && match_any($type, array_keys($version)))
			return key_of($type, $version);

		return $version["compatibility"].".".$version["framework"].".".$version["release"];

	}

	// Public objects

	public function data($table = "", $config = [], $options = []) {

		$db = "";
		$auto_create = false;

		if (is_string($config))
			$db = $config;

		else if (is_bool($config))
			$auto_create = $config;

		else if (is_array($config))
			$auto_create = true;


		require_once "data.classes.php";

		$data = new KB_data($this);

		if (not_empty($table))
			$data->db_table($table, $auto_create);

		if (not_empty($options))
			$data->db_table_options($options);

		if (not_empty($config) && is_array($config))
			$data->db_column_options($config);

		if (not_empty($db))
			$data->db_name($db);

		return $data;

	}

	public function data_group($table = "", $config = "") {

		$db = "";
		$auto_create = false;

		if (is_string($config))
			$db = $config;

		else if (is_bool($config))
			$auto_create = $config;

		else if (is_array($config))
			$auto_create = $config;

		require_once "data.classes.php";

		$data = new KB_data_group($this);

		if (not_empty($table))
			$data->db_table($table, $auto_create);

		if (not_empty($db))
			$data->db_name($db);

		return $data;

	}

	public function data_property() {

		require_once "data.classes.php";
		return new KB_data_property($this);

	}

	public function filesystem($dir = "") {

		require_once "file.classes.php";

		$filesystem = new KB_filesystem($this);

		if (!any_empty($dir, is_string($dir)))
			$filesystem->dir($dir);

		return $filesystem;
	}

	public function file() {
		require_once "file.classes.php";
		$file = new KB_file($this);
		$file->fs = new KB_filesystem($this);
		return $file;
	}

	public function folder() {
		require_once "file.classes.php";
		$folder = new KB_folder($this);
		$folder->fs = new KB_filesystem($this);
		return $folder;
	}

	public function form() {

		$identifier = debug_backtrace();
		$identifier = "i".md5($identifier[0]["file"].$identifier[0]["line"]);

		require_once "form.class.php";

		$form = new KB_form($this);
		$form->identifier = $identifier;

		if (BACKEND)
			$this->template->backend->head(
				$this->html->render(
					$this->html->tag("link", array("rel"=>"stylesheet", "href"=>"form.css?version=".filemtime(DROOT.BACKEND_TEMPLATE."form.css"), "type"=>"text/css"))
				)
			);

		return $form;
	}

	public function format($new = true) {

		$identifier = debug_backtrace();
		$identifier = md5($identifier[0]["file"].$identifier[0]["line"]);

		if (!class_exists('KB_format')) {
			require_once "view.classes.php";
		}

		if ($new || !isset($this->format)) {
			$temp_content = new KB_format($this);
			$temp_content->identifier = $identifier;
		}

		if ($new)
			return $temp_content;

		else {
			if (isset($this->format) && is_object($this->format)) {

				$this->format->identifier = $identifier;
				return $this->format;
			}
			else {

				$this->format = $temp_content;
				return $this->format;
			}
		}
	}

	public function ftp() {
		require_once "ftp.class.php";
		return new KB_ftp($this);
	}

	public function ldap() {

		require_once "ldap.class.php";
		return new KB_ldap($this);

	}

	public function lists() {
		require_once "view.classes.php";
		return new KB_lists($this);
	}

	public function mail() {
		require_once "mail.class.php";
		return new KB_mail($this);
	}

	public function pagination() {

		include_once "pagination.class.php";
		$identifier = debug_backtrace();
		$identifier = "i".md5($identifier[0]["file"].$identifier[0]["line"]);
		$pagination_o = new KB_pagination($this);
		$pagination_o->identifier = $identifier;
		return $pagination_o;
	}

	public function table() {

		require_once "view.classes.php";

		$identifier = debug_backtrace();
		$identifier = "i".md5($identifier[0]["file"].$identifier[0]["line"]);

		$table = new KB_tables($this);
		$table->identifier = $identifier;
		return $table;
	}

	public function xml($namespace = "") {

		require_once "html.class.php";

		$xml = new KB_html($this);
		$xml->config("type","xml");
		$xml->config("namespace",$namespace);
		$xml->config("empty_elements", ["rect"]);

		return $xml;

	}

	public function zip() {
		require_once "zip.class.php";
		return new KB_zip($this);
	}

	// PRIVATE

	// Private Objects

	private function array_object() {

		if ($this->init) {
			require_once "array.class.php";
			return new KB_array($this);
		}

		else {

			deprecated('Use $core->array instead of $core->array_o()');
			if (isset($this->array))
				return $this->array;
		}
		return false;
	}

	private function string_object() {

		if (isset($this->string))
			return $this->string;

		require_once "string.classes.php";
		return new KB_string($this);
	}

	private function csv_object() {

		if (isset($this->csv))
			return $this->csv;

		require_once "csv.class.php";
		return new KB_csv($this);
	}

	private function blog() {
		require_once "content.classes.php";
		return new KB_blog($this);
	}

	private function calc() {
		require_once "calc.class.php";
		return new KB_calc($this);
	}

	private function color() {
		require_once "color.class.php";
		return new KB_color($this);
	}

	private function content() {

		if ($this->init) {

			require_once "content.classes.php";
			$content = new KB_content($this);

			$content->db_table(
				"kb_content",
				[
					"name",
					"archived" => "false",
					"content"=>"text",
					"head"=>"text",
					"is_file"=>"false",
					"filename",
					"filealias",
					"secure"=>"false",
					"meta_title",
					"meta_keywords",
					"meta_description"=>"text",
				]
			);

			$content->position(true);
			$content->expandable(true);
			$content->statistic(true);
			$content->group = $this->content_group($content);
			$content->cache(true);
			$content->properties(true);

			if (
				$this->runs("backend") &&
				(($this->user->data('group_ID')) != false) &&
				not_empty($ID = key_of($this->user->group->ID(),$this->config("user_group_has_structure")))
			) {

				$content->filter(array("group_ID" => $this->array->union(
					array($ID),
					$content->group->read_children($ID)
				)), true);
			}

			if (
				$this->runs("frontend") &&
				key_of("archived", $content->columns())
			) {
				$content->filter(["archived"=>"0"], true);
			}

			return $content;

		}

		else {

			deprecated('Use $core->content instead of $core->content_o()');

			if (isset($this->content))
				return $this->content;

		}

		return false;

	}

	private function content_group($content = false) {

		if ($this->init) {

			require_once "content.classes.php";

			$structure = new KB_structure($this);

			$structure->db_table($content, array(
				"name",
				"archived" => "false",
				"url_path_name",
				"default_content",
				"template_ID"=>"int(10) unsigned DEFAULT NULL",
				"defaultpath"=>"tinyint(1) NOT NULL DEFAULT '0'",
				"is_base_dir"=>"tinyint(1) NOT NULL DEFAULT '0'",
			));

			$structure->position(true);
			$structure->properties(true);
			// $structure->order(array("parent_ID"));
			$structure->link_root = '/';

			if (
				$this->runs("backend") &&
				$this->user->data('group_ID') != false &&
				not_empty(key_of($ID = $this->user->data('group_ID'),$this->config("user_group_has_structure")))
			) {

				// return $structure;
				$structure->link_root = $structure->structure_ID_to_path($ID);
				$structure->set_root($ID);
				$structure->filter(array("ID" => $this->array->union(
					array($ID),
					$structure->read_children($ID)

				)), true);
			}

			if (
				$this->runs("frontend") &&
				key_of("archived", $structure->columns())
			) {
				$structure->filter(["archived"=>"0"], true);
			}

			return $structure;

		}

		else {

			deprecated('Use $core->content->group instead of $core->content_group_o()');

			if (!$content)
				$content = $this->content;
		}

		return false;

	}

	private function correlation() {

		require_once "data.classes.php";

		$data = new KB_correlation($this);

		$data->db_table(
			"kb_correlation",
			array(
				"table_ID_1"=>"INT( 10 ) UNSIGNED NOT NULL",
				"entry_ID_1"=>"INT( 10 ) UNSIGNED NOT NULL",
				"table_ID_2"=>"INT( 10 ) UNSIGNED NOT NULL",
				"entry_ID_2"=>"INT( 10 ) UNSIGNED NOT NULL",
			)
		);
		$data->db_table_options(array(
			"KEY (`table_ID_1`)",
			"FOREIGN KEY (`table_ID_1`) REFERENCES `".$this->kb_tables->db_table()."` (`ID`) ON DELETE CASCADE ON UPDATE CASCADE",
			"KEY (`table_ID_2`)",
			"FOREIGN KEY (`table_ID_2`) REFERENCES `".$this->kb_tables->db_table()."` (`ID`) ON DELETE CASCADE ON UPDATE CASCADE",

		));
		$data->indexed(true);

		return $data;
	}

	private function db() {

		if ($this->init) {

			$db_config = $this->core_config("db");

			if (is_empty($db_config))
				return false;

			// Deprecated
			if (!defined("DB_PREFIX"))
				define('DB_PREFIX', (fetch("prefix",$db_config)) ? fetch("prefix",$db_config)."__" : "");

			foreach($db_config as $configkey => $config) {

				if ($configkey != "prefix" && empty($config))
					return false;

			}

			require_once "db.classes.php";

			try {
				$db = new KB_db($this, $db_config);
			}

			catch (PDOException $e) {
				$this->db_error = $e->getMessage();
				return false;
			}

			return $db;

		}

		else {

			deprecated('Use $core->db instead of $core->db_o()');

			if (is_object($this->db))
				return $this->db;
		}
		return false;
	}

	private function exec() {

		if ($this->init) {
			require_once "exec.class.php";
			return new KB_exec($this);
		}

		else {

			deprecated('Use $core->exec instead of $core->exec_o()');

			if (isset($this->exec))
				return $this->exec;
		}
		return false;
	}

	private function html() {

		if ($this->init) {

			require_once "html.class.php";

			$html = new KB_html($this);
			$html->config("type","html");
			$html->config("empty_elements",array("br","frame","hr","img","input","meta","!doctype","link"));

			return $html;
		}

		else {

			deprecated('Use $core->html instead of $core->html_o()');

			if (isset($this->html))
				return $this->html;
		}

		return false;

	}

	private function kit() {

		if ($this->init) {

			require_once "kit.class.php";

			$kit =  new KB_kit($this);

			/*
			// Limit set in Kit Class to be able
			// to use any frontend Kit in backend

			if ($this->runs("backend")) {

				if (!$this->user->is_dev())
					$kit->data->filter(array(
						"ID" => $this->correlation->user_group_has($kit->data->db_table())
					), true);
	    }
			*/

			return $kit;

		}

		else {

			deprecated('Use $core->kit instead of $core->kit_o()');

			if (isset($this->kit))
				return $this->kit;

		}
		return false;
	}

	private function language() {

		if ($this->init) {

			require_once "language.classes.php";

			$language = new KB_language($this);

			$language->accept(
				$language->parse_accept(key_of('HTTP_ACCEPT_LANGUAGE',$_SERVER))
			);

			if (BACKEND) {
				$language->translation->add(CORE_FOLDER."translation");
			}

			return $language;
		}

		else {

			deprecated('Use $core->language instead of $core->language_o()');

			if (isset($this->language))
				return $this->language;
		}

		return false;

	}

	private function menu() {
		require_once "menu.class.php";
		return new KB_menu($this);
	}

	private function message() {

		if ($this->init) {

			require_once "message.class.php";
			return new KB_message($this);
		}

		else {
			if (isset($this->message))
				return $this->message;
		}

		return false;
	}

	private function pdf() {
		require_once "pdf.class.php";
		return new KB_pdf($this);
	}

	private function rest() {
		include_once "rest.class.php";
		return new KB_rest($this);
	}

	private function session() {

		if ($this->init) {
			require_once "session.class.php";
			return new KB_Session($this);
		}

		else {

			deprecated('Use $core->session instead of $core->session_o()');

			if (isset($this->session))
				return $this->session;
		}

		return false;
	}

	private function settings() {
		$core_table = $this->data("kb_core",array(
			"name",
			"value"=>"TEXT",
		));

		$core_table->indexed(true);
		$core_table->group(true);
		$core_table->group->expandable(true);
		$core_table->group->indexed(true);
		return $core_table;
	}

	private function statistic()	{

		$statistic = $this->data("kb_statistic",	array(
			"table_ID"=>"INT( 10 ) UNSIGNED NOT NULL",
			"entry_ID"=>"INT( 10 ) UNSIGNED NOT NULL, INDEX ( `entry_ID` )",
			"user_ID"=>"INT( 10 ) UNSIGNED NOT NULL",
			"date"=>"TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP",
			"description",
		));

		$statistic->db_table_options(array(
			"KEY `table_ID` (`table_ID`)",
			"FOREIGN KEY (`table_ID`) REFERENCES `".$this->kb_tables->db_table()."` (`ID`) ON DELETE CASCADE ON UPDATE CASCADE",
		));

		$statistic->key(false);
		$statistic->indexed(true);

		// TODO: Add correlation with kb_tables and kb_user

		return $statistic;
	}

	private function tables() {
		$table = $this->data("kb_tables",true);
		$table->expandable(true);
		$table->indexed(true);
		return $table;
	}

	private function template() {

		if ($this->init) {

			require_once "template.classes.php";

			$template = new KB_template($this);

			if ($this->db === false)
					return $template;

			$template->db_table(
				"kb_template",
				array(
					"name",
					"folder",
					"filename",
					"title",
					"favicon",
					"logo",
					"doctype",
					"interfaces",
					"meta_keywords",
					"meta_author",
					"meta_description",
					"viewport",
					"style" => "TEXT",
					"head" => "TEXT",
				)
			);

			$template->expandable(true);

			$template->icon->set_folder("/".$this->folder->path($this->path(),"core/template/icons"));

			if ($this->runs("backend") && $this->user->data('group_ID') && $this->get_config("user_group_has_template",$this->user->data('group_ID')) !== false) {
				$IDs = (is_array($this->get_config("user_group_has_template",$this->user->data('group_ID')))) ? $this->get_config("user_group_has_template",$this->user->data('group_ID')) : array($this->get_config("user_group_has_template",$this->user->data('group_ID')));
				$template->filter(array("ID" => $IDs));
			}

			return $template;

		}

		else {

			deprecated('Use $core->template instead of $core->template_o()');

			if (isset($this->template))
				return $this->template;
		}

		return false;

	}

	private function user() {

		if ($this->init) {

			require_once "user.class.php";
			return new KB_user($this);
		}

		else {
			if (isset($this->user))
				return $this->user;
		}

		return false;

	}

	private function video() {
		require_once "video.class.php";
		return new KB_video($this);
	}

	private function image() {
		require_once "image.class.php";
		return new KB_image($this);
	}

	private function view() {
		require_once "view.classes.php";
		return new KB_view($this);
	}

	private function svg() {

		if ($this->init) {
			require_once "html.class.php";

			$svg = new KB_html($this);
			$svg->config("type","xhtml");
			$svg->config("empty_elements", ["rect","path","circle"]);

			return $svg;
		}

		else {

			deprecated('Use $core->svg instead of $core->svg_o()');

			if (isset($this->svg))
				return $this->svg;
		}

		return false;

	}

	private function xhtml() {

		if ($this->init) {
			require_once "html.class.php";

			$xhtml = new KB_html($this);
			$xhtml->config("type","xhtml");
			$xhtml->config("empty_elements",array("br","frame","hr","img","input","meta","!doctype","link"));

			return $xhtml;
		}

		else {

			deprecated('Use $core->xhtml instead of $core->xhtml_o()');

			if (isset($this->xhtml))
				return $this->xhtml;
		}

		return false;

	}


	// Private Methods

	private function set_vars($keys = [], $purge = true) {

		$keys = (array) $keys;
		$vars = (array) $this->private_config("vars");

		if (is_empty($keys))
			$vars;

		// PHP 5.3 compatibility
		$array = array(
			"post" => &$_POST,
			"get" => &$_GET,
			"files" => &$_FILES,
			"session" => &$_SESSION,
			"cookie" => &$_COOKIE,
		);

		foreach($array as $key => &$values) {

			if (is_empty($values))
				continue;

			if (!value_fetch($key, $keys))
				continue;

			if (is_array($values)) {

				foreach ($values as $name => $value) {

					if (is_string($value))
						$value = htmlspecialchars($value, ENT_QUOTES);

					if (is_string($value) && $this->magic_quotes)
						$value = stripslashes($value);

					$vars[$key][$name] = $value;
				}

			}

			else {

				$value = $values;

				if (is_string($value))
					$value = htmlspecialchars($value, ENT_QUOTES);

				if (is_string($value) && $this->magic_quotes)
					$value = stripslashes($value);

				$vars[$key][$name] = $value;
			}

			if ($purge)
				$values = [];

		}

		$this->private_config("vars", $vars);
		return ($vars);

	}

	private function core_kits() {

		require_once "kit.class.php";

		$core_kits = new KB_kit($this);
		return $core_kits;

	}

	private function get_core_value($val) {

		if ($this->db === false)
				return null;

		if (is_indexed($val, true)) {

			$core_values = [];

			foreach ($val as $key) {
				$core_values[$key] = $this->get_core_value($key);
			}

			return $core_values;

		}

		if (is_array($val)) {

			foreach ($val as $key => $value)
				$this->write_core_data($key, $value);

			return $this->get_core_value(array_keys($val));
		}

		if (!is_string($val))
			return NULL;

		$config = $this->private_config("config");

		if (is_empty($config)) {

			$groups = $this->data->group->read();
			$data = $this->data->read();
			$data = $this->array->group_by($data, "group_ID");

			foreach ($groups as $group) {

				$key = key_of("name", $group);

				if (is_empty($values = key_of(key_of("ID", $group), $data)))
					continue;

				foreach ($values as $value) {
					$config[$key][key_of("name", $value)] = $this->json->decode(key_of("value", $value));
				}
			}

			$this->private_config("config",$config);

		}

		if (!is_null($return = key_of($val, key_of($this->config_creator, $config))))
			return $return;

		return key_of($val, key_of("Core", $config));

	}

	private function write_core_data($key, $value){

		$config_creator = $this->data->group->entry(["name"=>$this->config_creator]);
		$config = $this->private_config("config");

		if (is_empty($config_creator))
			$config_creator = [
				"ID" => $this->data->group->create(["name"=>$this->config_creator])
			];

		$entry = $this->data->entry(
			array(
				"name"=>$key,
				"group_ID"=>$config_creator["ID"],
			)
		);

		// Update cache
		$config[$this->config_creator] = either(key_of($this->config_creator, $config), []);
		$config[$this->config_creator][$key] = $value;
		$this->private_config("config",$config);

		if (is_empty($entry))
			return $this->data->create(
				array(
					"name"=>$key,
					"value"=>$value,
					"group_ID"=>$config_creator["ID"],
				)
			);

		return $this->data->update(
			array(
				"name"=>$key,
				"value"=>$value
			),
			array(
				"name"=>$key,
				"group_ID"=>$config_creator["ID"],
			)
		);
	}

	// ALIAS

	public function get($name = "", $source = array("set","get","post","session","cookie","files")) {
		return $this->get_var($name, $source);
	}

	public function set($name = "", $value = "") {
		return $this->set_var($name, $value);
	}


	// Alias for compatibility
	// Might become deprecated

	public function generate_url($options = [], $set_absolute = false) {
		return $this->url($options, $set_absolute);
	}

	public function generate_url_decoded($options = [], $set_absolute = false) {
		return $this->url_decoded($options, $set_absolute);
	}

	public function blog_o() {
		return $this->blog();
	}

	public function content_o() {
		deprecated();
		return $this->content();
	}

	public function content_group_o() {
		return $this->content_group();
	}

	public function data_o($table = "", $config = "", $options = []) {
		return $this->data($table, $config, $options);
	}

	public function data_group_o($table = "", $config = "") {
		return $this->data_group($table, $config);
	}

	public function data_property_o() {
		return $this->data_property();
	}

	public function form_o() {

		$identifier = debug_backtrace();
		$identifier = "i".md5($identifier[0]["file"].$identifier[0]["line"]);
		$form = $this->form();
		$form->identifier = $identifier;

		return $form;
	}

	public function ftp_o() {
		return $this->ftp();
	}

	public function ldap_o() {
		return $this->ldap();
	}

	public function lists_o() {
		return $this->lists();
	}

	public function mail_o() {
		return $this->mail();
	}

	public function menu_o() {
		return $this->menu();
	}

	public function pagination_o() {
		$identifier = debug_backtrace();
		$identifier = "i".md5($identifier[0]["file"].$identifier[0]["line"]);
		$pagination_o = $this->pagination();
		$pagination_o->identifier = $identifier;
		return $pagination_o;
	}

	public function statistic_o() {
		return $this->statistic();
	}

	public function svg_o() {
		return $this->svg();
	}

	public function table_o() {
		$identifier = debug_backtrace();
		$identifier = "i".md5($identifier[0]["file"].$identifier[0]["line"]);
		$table = $this->table();
		$table->identifier = $identifier;
		return $table;
	}

	public function tables_o() {
		$identifier = debug_backtrace();
		$identifier = "i".md5($identifier[0]["file"].$identifier[0]["line"]);
		$table = $this->table();
		$table->identifier = $identifier;
		return $table;
	}

	public function template_o() {
		return $this->template();
	}

	public function xhtml_o() {
		return $this->xhtml();
	}

	public function xml_o($namespace = "") {
		return $this->xml($namespace);
	}


	// DEPRECATED

	public function calc_o() {
		deprecated();
		return $this->calc();
	}

	public function array_o() {
		deprecated();
		return $this->array_object();
	}

	public function core_o() {
		deprecated();
		return $this->settings();
	}

	public function correlation_o() {
		deprecated();
		return $this->correlation();
	}

	public function db_o() {
		deprecated();
		return $this->db();
	}

	public function exec_o() {
		deprecated();
		return $this->exec();
	}

	public function filesystem_o() {
		deprecated();
		return $this->filesystem();
	}

	public function html_o() {
		deprecated();
		return $this->html();
	}

	public function kb_tables() {
		deprecated();
		return $this->tables();
	}

	public function kit_o() {
		deprecated();
		return $this->kit();
	}

	public function language_o() {
		deprecated();
		return $this->language();
	}

	public function message_o() {
		deprecated();
		return $this->message();
	}

	public function rest_o() {
		deprecated();
		return $this->rest();
	}

	public function session_o() {
		deprecated();
		return $this->session();
	}

	public function user_o() {
		deprecated();
		return $this->user();
	}

	public function content_group_property_o() {

		deprecated('Use of $core->content_group_property_o() is obsolete');

	}

	public function user_property_o() {

		deprecated('Use of $core->user_property_o() is obsolete');

		if (isset($this->user->properties))
			return $this->user->properties;

		return false;
	}

	public function usergroup_o() {

		deprecated('Use $core->user->group instead of $core->usergroup_o()');

		if (isset($this->user->group))
			return $this->user->group;

		return false;
	}

	public function msg_o() {
		deprecated('Use $core->message instead of $core->msg_o()');
		return $this->message;
	}

	public function get_url_options() {
		deprecated();
		return $this->url_options();
	}

	public function set_url_options($set=false, $set_absolute = false){
		deprecated();
		return $this->url_options($set,$set_absolute);
	}

	public function structure_o(){
		deprecated('Use $core->content->group instead of $core->structure_o()');
		return $this->content->group;
	}

	public function get_config_data() {

		deprecated();

		if (!count($this->core_config)){
			$this->core_config = array_multimerge($this->core_config(),$this->config());
		}
		return $this->core_config;
	}

	public function get_config($config, $key=false) {

		deprecated();

		$core_config = $this->get_config_data();

		if ($key){
			return either(key_fetch($key, key_fetch($config, $core_config)), false);
		}
		else{
			return either(key_fetch($config, $core_config), false);
		}
	}

	public function unset_object($obj_name) {
		deprecated("unset_object doesnt exists");
	}

}


class KB_installation extends KB_Core{

	private $core;

	function __construct($core){
		$this->core = $core;
	}


	public function core_config($key=false){
		return parent::core_config($key);
	}


	public function restore_database() {

		if ($this->core->file->exists(KB_FOLDER."kitbooth.sql")) {

			$db_config = key_of("db",$this->core_config());
			$mb = exec('mysql --user='.$db_config['user'].' --password='.$db_config['password'].' -h '.$db_config['server'].' -D '.$db_config['database'].' < '.$this->core->filesystem->get_path(KB_FOLDER."kitbooth.sql"), $out, $ret);
			$this->core->filesystem->delete(KB_FOLDER."kitbooth.sql");
			$this->core->refresh();
		}
	}


	public function default_config() {

		if (is_empty($this->core->data->columns())){

			$this->core->config("admin_email","");
			$this->core->config("form_email","");
			$this->core->config("password_cycles",floor(100 + rand(0,100)));
			$this->core->config("username_is_email","1");

		}
	}

}