<?php

class KB_csv extends KB_class_extended {

	private $core;

	function __construct ($core) {

		$this->core = $core;

	}


	// PUBLIC

	public function parse($string = "") {

		if (is_empty($string))
			return [];

		$data = [];

		foreach (str_getcsv($string,"\n") as $row) {

			$data[] = str_getcsv($row,";");

		}

		if (any_empty(key_of("0", $data), key_of("1", $data)))
			return [];

		$keys = key_of(0, $data);

		$data = remove_keys_of("0", $data);

		$data = array_values($data);

		foreach ($data as $index => $row) {
			$data[$index] = array_combine($keys,$row);
		}

		return $data;

	}

	public function render($data = [], $options = []) {

		if (any_empty(not_empty($data), is_array($data)))
			return "";

		$options = $this->core->array->merge([
			"exclude" => []
		],$options);

		$keys = [];

		foreach ($data as $entry) {

			foreach ($entry as $key => $value) {

				$keys[$key] = "";

			}

		}

		$keys = remove_keys_of(key_of("exclude", $options), $keys);

		$return = "";

		foreach (array_keys($keys) as $key)
			$return .= $key.";";

		$return .= br;

		foreach ($data as $entry) {
			foreach ($keys as $key => $value) {

				$value = either(key_of($key, $entry), $value);

				if (!is_numeric($value))
					$value = '"'.$value.'"';

				$return .= $value.";";
			}
			$return .= br;
		}
		return $return;
	}
}