<?php

class KB_image extends KB_class {

	private $core;

	function __construct ($core) {

		$this->core = $core;

	}

	public function raster($file = "", $type = "png") {

		if (is_empty($file))
			return false;

		if (is_empty(loaded("imagick")))
			return false;

	}

	public function size ($file, $size, $folder = ".cache/thumbs/") {

	}

	public function width ($img = "", $width = 0, $folder = "") {

		$core = $this->core;
		// return $img;

		if (is_empty($folder))
			$folder = ".cache/thumbs/".$width."/";

		if (any_empty($img, is_string($img), is_numeric($width)))
			return $img;

		if (!$core->array->match(
			$core->file->extension($img),
			array("jpg", "jpeg", "png", "gif", "bmp")
		))
			return $img;


		if ($core->file->exists($img))
			$source = $core->file->get_path($img);

		else if ($core->file->exists($core->folder->path($core->path("root", "files"),$core->folder->part($img)).$core->file->name($img)))
			$source = $core->folder->path($core->path("root", "files"),$core->folder->part($img)).$core->file->name($img);

		else if ($core->file->exists($core->folder->path($core->path("root", "kitbooth"),$core->folder->part($img)).$core->file->name($img)))
			$source = $core->folder->path($core->path("root", "kitbooth"),$core->folder->part($img)).$core->file->name($img);

		else
			return $img;

		$file_name = $core->file->name($img);

		$target_folder = $core->filesystem->path($core->folder->part($img),$folder);
		$source_folder = $core->folder->part($source);
		$target = $core->filesystem->path($core->folder->part($source),$folder).$file_name;
		$filemtime = $core->file->age($source, array("age"=>"modified"));

		if (
			$core->file->exists($target) &&
			$filemtime <= $core->file->age($target, array("age"=>"modified"))
		)
			return "/".$target_folder.$core->file->name($target)."?version=".$filemtime;

		$core->folder->create($core->folder->part($target));

		list($width_orig, $height_orig) = getimagesize($source);

		if ($width_orig <= $width)
			return $img;



		$height = $width * ($height_orig/$width_orig);

		// Resample

		if (preg_match("/.jpg/i",$file_name) || preg_match("/.jpeg/i",$file_name)) {

			if (!matches("image/jpeg", mime_content_type($source)))
				return $img;

				// return $img."?height=".$height."&width=".$width;
			if (!function_exists("imagecreatefromjpeg"))
				return $img;


			$image = imagecreatefromjpeg($source);

			// if (function_exists('exif_read_data')) {
			//
			// 	$exif = exif_read_data($source,'EXIF');
			//
			// 	if (not_empty($orientation = key_of("Orientation", $exif))) {
			// 		$degree = array("1"=>"0","3"=>"180","6"=>"270","8"=>"90");
			// 		$degree = key_of($orientation, $degree);
			//
			// 		if ($degree)
			// 		$image = imagerotate($image, $degree, 0);
			//
			// 		if (value_fetch($orientation, array("6","8"))) {
			// 			list($width,$height) = array($height,$width);
			// 			list($width_orig,$height_orig) = array($height_orig,$width_orig);
			// 		}
			//
			// 	}
			//
			// }

			$image_p = imagecreatetruecolor($width, $height);

			imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
			imagejpeg($image_p, $target, 90);
		}

		else if (preg_match("/.png/",$file_name)) {

			$image_p = imagecreatetruecolor($width, $height);

			if (!matches("image/png", mime_content_type($source)))
			return $img;

			$image = imagecreatefrompng($source);
			imageAlphaBlending($image_p, false);
			imagesavealpha( $image_p, true );
			imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
			imagepng($image_p, $target, 9);
		}

		else if (preg_match("/.gif/",$file_name)) {

			if (!matches("image/gif", mime_content_type($source)))
			return $img;

			$image = imagecreatefromgif($source);
			imagecolortransparent($image_p);
			imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
			imagegif($image_p, $target);
		}

		else if (preg_match("/.bmp/",$file_name)) {

			if (!matches("image/bmp", mime_content_type($source)))
			return $img;

			if (!is_callable("imagecreatefrombmp") || !is_callable("imagebmp"))
			return $img;

			$image = imagecreatefrombmp($source);
			imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
			imagebmp($image_p, $target);
		}

		touch($target,$filemtime);
		return "/".$target_folder.$file_name."?version=".$filemtime;

	}
}