<?php

class KB_pdf extends KB_class {


	private $core;

	function __construct ($core) {

		$this->core = $core;

	}


	public function image($source = "", $target_folder = "", $options = array()) {

		if (any_empty($source, $target_folder))
			return false;

		if (!matches("pdf",$this->core->file->extension($source)))
			return false;

		$options = $this->core->array->merge(
			array(
				"filetype" => "jpg",
				"pages" => true,
				"size" => 1000,
				"modified" => false,
			),
			$options
		);

		if (any_empty(
			loaded("imagick"),
			loaded("ghostscript")
			))
			return false;

		if ($this->core->file->exists($source))
			$source = $this->core->file->get_path($source);

		else if ($this->core->file->exists($this->core->folder->path(DROOT,FILES_FOLDER,$this->core->folder->part($source)).$this->core->file->name($source)))
			$source = $this->core->folder->path(DROOT,FILES_FOLDER,$this->core->folder->part($source)).$this->core->file->name($source);

		else if ($this->core->file->exists($this->core->folder->path(DROOT,KB_FOLDER,$this->core->folder->part($source)).$this->core->file->name($source)))
			$source = $this->core->folder->path(DROOT,KB_FOLDER,$this->core->folder->part($source)).$this->core->file->name($source);

		else
			return $source;


		if (is_array($size = key_of("size", $options)))
			list($size_w, $size_h) = $size;

		else
			list($size_w, $size_h) = array($size, $size);

		// $target_file = preg_replace(
		// 	preg_mod($this->core->file->extension($source)),
		// 	key_of("filetype",$options),
		// 	$this->core->file->name($source)
		// );

		$target_file = $this->core->file->basename($source).".".key_of("filetype",$options);
		$target = $this->core->folder->path($this->core->folder->part($source), $target_folder).$target_file;


		// $target = $this->core->filesystem->path($target_folder).$target_file;

		if (
			$this->core->file->exists($target)
			&& $this->core->file->age($source) <= $this->core->file->age($target, array("age"=>"modified"))
			)
			return $target_file;

		try {
			// $file = new imagick($source);
			$file = new imagick();
			$file->readImage($source."[0]");
		} catch (Exception $e) {
			$this->core->message->dev($e,"Error",2);
			return false;
		}

		// $file->setIteratorIndex(key_of("pages", $options));
		$file->setImageAlphaChannel(Imagick::VIRTUALPIXELMETHOD_WHITE);
		$file->setImageFormat(key_of("filetype",$options));
		$file->thumbnailImage($size_w, $size_h, true);

		if (!$this->core->file->write($target, $file->getImageBlob()))
			return false;

		if ($filemtime = key_of("modified", $options))
			$this->core->file->touch($target, $filemtime);


		return $target_file;

	}


}