//Video5
'use strict';
var Video5 = new Object();
var jQuery;

Video5.object = new Object();
Video5.timeout = 1000;
Video5.fade_time = 500;
Video5.i = 0;
Video5.volume = 1;

//Init after loaded Dependencies

Video5.onload = function() {

	jQuery(document).ready(function(){
		//Video5.parse();
		ready('.video video', function(element) {
			Video5.parse(jQuery(this));
		});
	});

};

//Load Dependencies

Video5.load = function() {

	if (typeof(jQuery) == 'undefined') {
		Video5.getScript('//code.jquery.com/jquery-1.11.0.min.js', function() {
			Video5.load();
		});

		return false;
	}

	else {
		Video5.onload();
	}
};


Video5.getScript = function (url, success) {
	var script     = document.createElement('script');
	script.src = url;
	var head = document.getElementsByTagName('head')[0],
	done = false;

	// Attach handlers for all browsers
	script.onload = script.onreadystatechange = function() {

		if (!done && (!this.readyState || this.readyState == 'loaded' || this.readyState == 'complete')) {

		done = true;
		// callback function provided as param
		success();
		script.onload = script.onreadystatechange = null;
		head.removeChild(script);

		};
	};
	head.appendChild(script);
};


Video5.parse = function(object){

	Video5.volume = jQuery.cookie("Video5_volume") || 1;

	object = object || jQuery(".video video");

	object.each(function(){

		Video5.i++;

		var i =  Video5.i;

		Video5.object[i] = $(this).parent();
		Video5.object[i].addClass("Video5");
    Video5.object[i].timeout = false;
		Video5.object[i].playlist = false;
    Video5.object[i].video = $(this);
		Video5.object[i].video.removeAttr("controls");

		Video5.object[i].options = {"time":true,"volume":true};
		var options = false;
		if (options = Video5.object[i].video.attr("data-video")) {
			options = options.replace(/'/g,"\"");
			options = jQuery.parseJSON(options);
			Video5.object[i].options = Object.assign(options,Video5.object[i].options);
		}


		// Timeline
		Video5.object[i].timeline = jQuery("<div></div>").addClass("timeline fade");
		Video5.object[i].timeline.click(function(e){
			var offset = $(this).offset();
  		var x = e.pageX - offset.left;
			var p = x / $(this).width();
			var time = Video5.object[i].video.prop("duration") * p;
			Video5.object[i].video[0].currentTime = time;

		});
		Video5.object[i].current_timeline = jQuery("<div></div>").addClass("current_timeline");
		Video5.object[i].current_timeline.appendTo(Video5.object[i].timeline);
		Video5.object[i].video.after(Video5.object[i].timeline);

		Video5.object[i].video.on("timeupdate", function(){
    	Video5.object[i].current_timeline.css("width", (this.currentTime*100/this.duration)+"%");
			if (Video5.object[i].options["time"]) {
				Video5.object[i].time.current.text(Video5.time(Video5.object[i].video[0].currentTime));
			}
  	});

		Video5.object[i].video.on("click", function(){
			if (Video5.object[i].video[0].paused)
				Video5.object[i].video[0].play();
			else
				Video5.object[i].video[0].pause();
  	});


		// Fullscreen
		if (Video5.object[i].options["fullscreen"]) {
			Video5.object[i].fullscreen = jQuery("<a></a>").addClass("fullscreen fade");
			// Video5.object[i].fullscreen.attr("href", Video5.object[i].video.attr("src"));

			Video5.object[i].fullscreen.click(function(){
				Video5.fullscreen(i);

			});

			if (Video5.object[i].options["fullscreen"]["class"])
				Video5.object[i].fullscreen.addClass(Video5.object[i].options["fullscreen"]["class"]);

			Video5.object[i].video.after(Video5.object[i].fullscreen);

		}

		// Play Button
		Video5.object[i].play = jQuery("<div></div>").addClass("play_pause paused fade");
		Video5.object[i].play.click(function(){
			if (Video5.object[i].video[0].paused)
				Video5.object[i].video[0].play();
			else
				Video5.object[i].video[0].pause();
		});

		Video5.object[i].video.after(Video5.object[i].play);

		Video5.object[i].video.on("play", function(){

			jQuery.each(Video5.object, function(key, value){
				if (key != i)
				value.video[0].pause();
			});
			Video5.object[i].play.removeClass("paused");
			Video5.fade_out(i);

			if(Video5.object[i].playlist)
				Video5.object[i].playlist.fadeOut();

			if (Video5.object[i].options["time"])
				Video5.object[i].time.current.show();


		});
		Video5.object[i].video.on("pause", function(){
			Video5.object[i].play.addClass("paused");
			if (Video5.object[i].video[0].currentTime == Video5.object[i].video[0].duration && Video5.object[i].playlist)
				Video5.object[i].playlist.fadeIn();
		});


		// Title
		if (Video5.object[i].options["title"]) {
			Video5.object[i].title = jQuery("<div></div>").addClass("title fade");
			Video5.object[i].title.html(Video5.object[i].options["title"]);
			Video5.object[i].video.after(Video5.object[i].title);
		}


		// Time
		if (Video5.object[i].options["time"]) {
			Video5.object[i].time = jQuery("<div></div>").addClass("time fade");
			Video5.object[i].time.current = jQuery("<span></span>").text(Video5.object[i].video[0].currentTime).hide();
			Video5.object[i].time.total = jQuery("<span></span>").text(Video5.object[i].video[0].duration).hide();
			Video5.object[i].time.append(Video5.object[i].time.current).append(Video5.object[i].time.total);
			Video5.object[i].video.after(Video5.object[i].time);
			Video5.object[i].video.on("durationchange", function(){
				Video5.object[i].time.total.text(Video5.time(Video5.object[i].video[0].duration)).show();
			});
		}


		// Volume
		if (Video5.object[i].options["volume"]) {
			Video5.object[i].volume = jQuery("<div></div>").addClass("volume fade");
			Video5.object[i].volume.click(function(){

				if (Video5.object[i].video[0].volume > 0) {
					Video5.object[i].video[0].volume = 0;
					Video5.object[i].volume.addClass("muted");
				}

				else {
					Video5.object[i].video[0].volume = Video5.volume;
					Video5.object[i].volume.removeClass("muted");
				}

			});

			Video5.object[i].volume.slider = jQuery("<div></div>").addClass("slider");

			Video5.object[i].volume.slider.click(function(e){
				e.stopPropagation();
				var offset = $(this).offset();
	  		var y = ($(this).innerHeight() - (e.pageY - (offset.top))) / $(this).innerHeight();
				if (y < 0) y = 0;
				if (y > 1) y = 1;
				jQuery.cookie("Video5_volume",y,{ expires: 7, path: '/' });
				Video5.volume = y;
				jQuery.each(Video5.object, function(key, value){
					Video5.object[key].video[0].volume = y;
					Video5.object[key].volume.current_volume.css("height", (Video5.volume*100)+"%");
				});

				// var p = x / $(this).width();
				// var time = Video5.object[i].video.prop("duration") * p;
				// Video5.object[i].video[0].currentTime = time;

			});

			Video5.object[i].volume.current_volume = jQuery("<div></div>").addClass("current_volume");
			Video5.object[i].volume.current_volume.css("height", (Video5.volume*100)+"%");

			Video5.object[i].volume.slider.append(Video5.object[i].volume.current_volume);
			Video5.object[i].volume.append(Video5.object[i].volume.slider);
			Video5.object[i].video.after(Video5.object[i].volume);
		}


		// Includes
		if (Video5.object[i].options["include"])
			jQuery.each(Video5.object[i].options["include"], function(key, value){
				Video5.object[i].video.after(jQuery(value).clone());
			});

		//Playlist
		if (Video5.object[i].options["playlist"]) {
			Video5.object[i].playlist = jQuery("<div></div>").addClass("playlist");
			Video5.object[i].thumbs = new Array();
			jQuery.each(Video5.object[i].options["playlist"], function(key, value) {

				if (!value["src"])
					return;

				var thumb = jQuery("<div></div>").addClass("entry");
				jQuery("<img>").attr("src",value["poster"]).appendTo(thumb);

				if (value["title"])
					jQuery("<div></div>").addClass("title").html(value["title"]).appendTo(thumb);

				thumb.video = value["src"];
				thumb.title = value["title"] || "";
				thumb.poster = value["poster"] || "";
				Video5.object[i].thumbs[key] = thumb;
				thumb.click(function(){
					Video5.object[i].video[0].currentTime = 0;
					Video5.object[i].video[0].src = thumb.video;
					Video5.object[i].video[0].poster = thumb.poster;
					Video5.object[i].title.html(thumb.title);
					Video5.object[i].video[0].play();
					jQuery.each(Video5.object[i].thumbs, function(key, value) {
						if (value.video == Video5.object[i].video.attr("src"))
							value.hide();
						else
							value.show();
					});
					Video5.object[i].playlist.hide();
				});

				Video5.object[i].playlist.append(thumb);
				if(thumb.video == Video5.object[i].video.attr("src"))
					thumb.hide();
			});
			Video5.object[i].playlist.hide();
			Video5.object[i].video.after(Video5.object[i].playlist);
		}

		// Fade
		Video5.object[i].video.mousemove(function(){Video5.fade_in(i);});
		Video5.object[i].find($(".fade")).mousemove(function(){Video5.fade_in(i);});
		// Video5.fade_out(i);

  });
};


Video5.fade_out = function(i) {

		Video5.object[i].timeout = false;
		Video5.object[i].find(".fade").fadeOut(Video5.fade_time );

};


Video5.fade_in = function(i) {

		if(Video5.object[i].timeout) {
			clearTimeout(Video5.object[i].timeout);
			if(Video5.object[i].video[0].currentTime !== 0)
			Video5.object[i].timeout = setTimeout(function(){Video5.fade_out(i);}, Video5.timeout);
			return;
		}

		Video5.object[i].find(".fade").fadeIn(100);
		Video5.object[i].timeout = setTimeout(function(){Video5.fade_out(i);}, Video5.timeout);

};


Video5.fullscreen = function(i) {
	var paused = Video5.object[i].video[0].paused;
	if (!paused)
		Video5.object[i].video[0].pause();
	var close = jQuery(document.createElement("div")).addClass("Video5_close fade");
	close.click(function(){
		jQuery("div.Video5.fullscreen .Video5_content").empty();
		jQuery("div.Video5.fullscreen").hide();
	});
	if (jQuery("div.Video5.fullscreen").length == 0) {
		jQuery(document.createElement("div")).addClass("Video5 fullscreen").appendTo(jQuery("body")).hide().fadeIn();

		var content = jQuery(document.createElement("div")).addClass("Video5_content video").appendTo(jQuery("div.Video5.fullscreen"));
	}
	else {
		jQuery("div.Video5.fullscreen").fadeIn();
	}

	close.appendTo(jQuery("div.Video5 .Video5_content"));
	var video = jQuery("<video>").attr("src",Video5.object[i].video.attr("src"));
	video.attr("poster", Video5.object[i].video.attr("poster"));

	var options = Video5.object[i].options["fullscreen"] || "";
	options["title"] = options["title"] || Video5.object[i].options["title"];
	options = JSON.stringify(options);
	options = options.replace(/"/g,"'");

	video.attr("data-video",options);
	video.appendTo(jQuery("div.Video5 .Video5_content"))

	if (!paused)
		video[0].play();
};




(function(win) {

    var listeners = [],
    doc = win.document,
    MutationObserver = win.MutationObserver || win.WebKitMutationObserver,
    observer;

    function ready(selector, fn) {
        // Store the selector and callback to be monitored
        listeners.push({
            selector: selector,
            fn: fn
        });
        if (!observer) {
            // Watch for changes in the document
            observer = new MutationObserver(check);
            observer.observe(doc.documentElement, {
                childList: true,
                subtree: true
            });
        }
        // Check if the element is currently in the DOM
        check();
    }

    function check() {
        // Check the DOM for elements matching a stored selector
        for (var i = 0, len = listeners.length, listener, elements; i < len; i++) {
            listener = listeners[i];
            // Query for elements matching the specified selector
            elements = doc.querySelectorAll(listener.selector);
            for (var j = 0, jLen = elements.length, element; j < jLen; j++) {
                element = elements[j];
                // Make sure the callback isn't invoked with the
                // same element more than once
                if (!element.ready) {
                    element.ready = true;
                    // Invoke the callback with the element
                    listener.fn.call(element, element);
                }
            }
        }
    }

    // Expose `ready`
    win.ready = ready;

})(this);

(function (factory) {
	if (typeof define === 'function' && define.amd) {
		// AMD (Register as an anonymous module)
		define(['jquery'], factory);
	} else if (typeof exports === 'object') {
		// Node/CommonJS
		module.exports = factory(require('jquery'));
	} else {
		// Browser globals
		factory(jQuery);
	}
}(function ($) {

	var pluses = /\+/g;

	function encode(s) {
		return config.raw ? s : encodeURIComponent(s);
	}

	function decode(s) {
		return config.raw ? s : decodeURIComponent(s);
	}

	function stringifyCookieValue(value) {
		return encode(config.json ? JSON.stringify(value) : String(value));
	}

	function parseCookieValue(s) {
		if (s.indexOf('"') === 0) {
			// This is a quoted cookie as according to RFC2068, unescape...
			s = s.slice(1, -1).replace(/\\"/g, '"').replace(/\\\\/g, '\\');
		}

		try {
			// Replace server-side written pluses with spaces.
			// If we can't decode the cookie, ignore it, it's unusable.
			// If we can't parse the cookie, ignore it, it's unusable.
			s = decodeURIComponent(s.replace(pluses, ' '));
			return config.json ? JSON.parse(s) : s;
		} catch(e) {}
	}

	function read(s, converter) {
		var value = config.raw ? s : parseCookieValue(s);
		return $.isFunction(converter) ? converter(value) : value;
	}

	var config = $.cookie = function (key, value, options) {

		// Write

		if (arguments.length > 1 && !$.isFunction(value)) {
			options = $.extend({}, config.defaults, options);

			if (typeof options.expires === 'number') {
				var days = options.expires, t = options.expires = new Date();
				t.setMilliseconds(t.getMilliseconds() + days * 864e+5);
			}

			return (document.cookie = [
				encode(key), '=', stringifyCookieValue(value),
				options.expires ? '; expires=' + options.expires.toUTCString() : '', // use expires attribute, max-age is not supported by IE
				options.path    ? '; path=' + options.path : '',
				options.domain  ? '; domain=' + options.domain : '',
				options.secure  ? '; secure' : ''
			].join(''));
		}

		// Read

		var result = key ? undefined : {},
			// To prevent the for loop in the first place assign an empty array
			// in case there are no cookies at all. Also prevents odd result when
			// calling $.cookie().
			cookies = document.cookie ? document.cookie.split('; ') : [],
			i = 0,
			l = cookies.length;

		for (; i < l; i++) {
			var parts = cookies[i].split('='),
				name = decode(parts.shift()),
				cookie = parts.join('=');

			if (key === name) {
				// If second argument (value) is a function it's a converter...
				result = read(cookie, value);
				break;
			}

			// Prevent storing a cookie that we couldn't decode.
			if (!key && (cookie = read(cookie)) !== undefined) {
				result[name] = cookie;
			}
		}

		return result;
	};

	config.defaults = {};

	$.removeCookie = function (key, options) {
		// Must not alter options, thus extending a fresh object...
		$.cookie(key, '', $.extend({}, options, { expires: -1 }));
		return !$.cookie(key);
	};

}));


Video5.time = function(time) {
	var seconds = parseInt(time, 10);
	seconds = Math.floor(seconds);
	var minutes = Math.floor(seconds / 60);
	seconds = seconds - (minutes * 60);
	seconds = ("0" + seconds).slice(-2);
	// return this;
	return minutes+':'+seconds;
};


Video5.load();

