<?php

// Set dev messages

$core->message->dev("PHP runtime: ".runtime()." Seconds","Stats");

if ($core->db) {

	$core->message->dev("DB call count: ".$core->db_call_count,"Stats",ifttt($core->db_call_count > 13,1,0));
	$core->message->dev("DB query time: ".$core->db->showexectime(),"Stats",ifttt($core->db_call_count > 13,1,0));

	if ($core->config("log_queries"))
		$core->message->dev(array("DB calls: ",$core->html->table($core->db_call)),"Log",1);
}

// Toolkitsmenu

if (not_empty($core->template->backend->toolkits()))
	$core->template->backend->header($core->html->a($core->template->icon("config"),["class"=>"small button toolkit_menu","title"=>"Open Tools"]));
	// $core->template->backend->header($core->html->tag("a",$core->language->translate("Tools"),array("class"=>"toolkit_menu","title"=>"Open Tools")));

// Menu for signed in users

if (isset($core->user) && $core->user->logged_in()) {
	$core->template->backend->header(
		$core->html->tag("a",$core->template->icon("logout"),["href"=>$core->url(["logout"=>true],true),"class"=>"small button","title"=>"Sign out"])
	);

	if ($core->user->backend())
		$core->filesystem->read_php('menu.php');
}


// Link to frontend

$core->template->backend->header(
	// $core->html->tag("a","Frontend",array("href"=>"//".$_SERVER['HTTP_HOST'],"class"=>"small button","title"=>"Switch to Frontend"))
);

// Help link

/*
$core->template->backend->footer(
	$core->html->tag("a","Help",array("href"=>"http://www.kitbooth.com","title"=>"View help online"))
);
*/

if (isset($core->user) && $core->message->get_dev_messages() && $core->user->is_dev()) {
	$core->template->backend->footer(
		$core->html->tag("div",$core->html->tag("div",$core->message->get_dev_messages()),["class"=>ifttt($core->message->dev_status(),"message","red message")])
	);
}

if (isset($core->message) && $core->message->get_message() && isset($core->user) && $core->user->is_dev()) {
	$core->template->backend->footer(
		$core->html->tag("div",$core->html->tag("div",$core->message->get_message()), ["class"=>"blue message"])
	);
}


if (isset($core->message) && $core->message->get_info()) {
	$core->template->backend->footer(
		$core->html->tag("div",$core->html->tag("div",$core->message->get_info(), ["class"=>ifttt($core->message->status(),"green message","red message")]),["class"=>ifttt($core->message->status(),"green message","red message")])
	);
}


// Set libraries loaded in head


if (is_empty($core->template->backend->favicon()))
	$core->template->backend->favicon("favicon.ico");

if (is_empty($core->template->backend->touch_icon()))
	$core->template->backend->touch_icon("/core/template/images/icon_144.png");

$head = $core->html->tag("head", [
	$core->template->backend->css([
		"body.css",
		// "normalize.css",
		"footer.css",
		"menu.css",
		"kit.css",
		"table.css",
		"fonts/fonts.css",
		"Zoom5/Zoom5.css",
		"Slide5/Slide5.css",
		"jquery-ui.css",
	]),
	$core->template->backend->js([
		"jquery.js",
		"jquery-ui.js",
		"core.js",
		"body.js",
		"kit.js",
		"forms.js",
		"Zoom5/Zoom5.js",
		"Slide5/Slide5.js",
	]),
	$core->template->backend->head(),
	$core->html->tag("link",array("rel"=>"shortcut icon","href"=>$core->template->backend->favicon())),
	$core->html->tag("link",array("rel"=>"apple-touch-icon","href"=>$core->template->backend->touch_icon(),"sizes"=>"144x144")),
	$core->html->tag("title",$core->template->backend->title()),
	$core->html->tag("meta",array("http-equiv"=>"Content-Type","content"=>"text/html; charset=utf-8")),
	$core->html->tag("meta",array("name"=>"apple-mobile-web-app-capable","content"=>"yes")),
	$core->html->tag("meta",array("name"=>"viewport","content"=>"width=device-width, initial-scale=1.0")),
	$core->html->tag("meta",array("name"=>"theme-color","content"=>"hsl(206, 27%, 46%)")),
]);

// Header, main and sub menu

// $title = $core->html->tag("h1",$core->template->backend->title());
$header = $core->template->backend->header();
$logo = $core->html->tag("span","",["class"=>"logo"]);

$main_menu = $core->template->backend->main_menu();
$main_menu = ifttt($main_menu,$core->html->tag("div",[$main_menu], ["class"=>"main_menu"]),"");


$sub_menu = $core->template->backend->sub_menu();
$sub_menu = ifttt($sub_menu,$core->html->tag("div", [$sub_menu], ["class"=>"pane side_menu"]),"");

$header = $core->html->div([$logo, $main_menu, $core->html->div($header)],["class"=>"header"]);


// Kit and Toolkits
// $sub_menu

$content = $core->html->tag("div", [$core->template->backend->content()], ["class"=>"main"]);
$content = $core->html->tag("div", [$sub_menu,$content], ["class"=>"panes"]);
$content = $core->html->tag("div", $content, ["class"=>"kit"]);
$toolkits_pane = $core->html->tag("div",$core->template->backend->toolkits(), ["class"=>"toolkit_pane"]);

// Assembly page

$page = $core->html->tag("div", [$content, $toolkits_pane], ["class"=>"page"]);


// Help, notices and info

$footer = $core->html->tag("div",$core->template->backend->footer(), ["class"=>"element"]);
$notice = $core->template->backend->notice();
$notice = $core->html->tag("span",$notice, ["class"=>"notice"]);
$hints = $core->html->tag("span","", ["class"=>"info"]);


// Assembly footer

$footer = $core->html->tag("div", [$footer, $hints, $notice], ["class"=>"footer"]);

// Put everything together

$body = $core->html->tag("body", [$header, $page, $footer],$core->template->backend->body());
$html = $core->html->tag("html", [$head, $body], ["lang"=>key_of(0,$core->language->accept())]);

// Output

echo $core->html->render([
	"<!DOCTYPE html>".br,
	$html
]);
