//Turn on automatic form submit on dropdown elements with classname 'autosubmit'.
//Hide submit buttons in forms with only such elements.
$(function()
{
	var elements = $('select, input[type="date"], input[type="radio"]');
	elements.each(function(){
		var element	= $(this);
		if(element.hasClass("autosubmit")){
			var element	= $(this);
			var form = element.parents("form").first();

			element.change(function(){
				form.find('button[type="submit"]').click();
			});

			if (form.find('input[type!="date"]').length > 0 && !form.hasClass("autosubmit"))
				return;

			form.find('button[type="submit"], div.submit').hide();

		}
	});
});

var KB = {
	"duplicate_form_fields":{}
};

// Duplicate Form Fields which support multiple inputs
$(function(){

	var elements = $('input[data-array],select[data-array],textarea[data-array],span[data-array]');

	elements.each(function(){
		var element	= $(this);
		var name = element.attr("data-array").replace(/([0-9a-z_]+)(.+)/,"$1");
		var index = parseInt(element.attr("data-array").replace(/([0-9a-z_]+)\[([0-9]+)\]/,"$2"));

		if (
			KB["duplicate_form_fields"][name] === undefined ||
			KB["duplicate_form_fields"][name] < index
		) {
			KB["duplicate_form_fields"][name] = index;
		}
	});

	$.each(KB["duplicate_form_fields"], function(name, index){

		$('*[data-array="'+name+"["+index+']"]').each(function(){
			var element	= $(this);
			var button = $('<a><strong>+</strong></a>');
			button.addClass("small button");
			button.attr("data-for",element.attr("data-array"));
			button.click(function(){
				duplicate_form_field($(this).attr("data-for"));
			});
			element.wrap('<div class="duplicate_form_field"></div>');
			element.after(button);
		});
	});
	duplicate_form_field_row();
});

function duplicate_form_field(data_for){
	obj = $('*[data-array="'+data_for+'"]').eq(0);
	if(obj.length > 0){
		old_value = obj.attr("data-array").match(/([0-9a-z]+)([[]+)([0-9]+)/);
		new_value = obj.attr("data-array").replace(/([0-9a-z]+)([[]+)([0-9]+)/,"$1$2"+(++old_value[3]));
		new_obj = obj.clone(true).attr("data-array",new_value).attr("id",new_value).attr("value","");
		new_obj.not("select").val("");
		new_obj.children("option").removeAttr("selected");
		new_obj.find("input").each(function(){
			var id = $(this).attr("id");
			id = id.replace(old_value[0]+"]",new_value);
			$(this).attr("id",id);
			var name = $(this).attr("name");
			name = name.replace(old_value[0]+"]",new_value);
			// $(this).attr("name",name);
			$(this).removeAttr("checked");
			$(this).next("label").attr("for",id);
		});
		// obj.after(new_obj).after("<br>");
		obj.after(new_obj);
		$('a[data-for="'+obj.attr("data-array")+'"]').attr("data-for",new_value);
	}
}

function duplicate_form_field_row(){

	$("table.data tr").each(function(){

		var elements = $(this).find('a[data-for]');
		var fields = new Array();
		$(this).find('input, textarea, select').each(function(){
			var name = $(this).attr("name");
			if(name){
				name = name.replace(/([[]+)(.*)/,"");
			}
			if($.inArray(name,fields) == -1){
				fields.push(name);
			}
		});

		if(elements.length == fields.length && elements.length > 1){
			elements.hide();
			var button = $('<a><strong>+ +</strong></a>');
			button.addClass("small button");
			button.click(function(){
				elements.click();
			})
			$(this).find("td").slice(-1).append(button);
			// element = button.prevAll("input, select").eq(0);
			// if(element.css("display") == "block")
				// element.css("display","inline-block");
		}
	});
}

// Expandible Textareas

$(function(){

  $("textarea:not([readonly])").not(".html_editor").wrap(
    '<div class="textarea_plus"></div>'
  );
  $(".textarea_plus").each(
    function(){
      textarea = $(this).find("textarea");
      input = $("<div contenteditable></div>").text(
        textarea.text()
      ).attr("style",
        textarea.attr("style")
      ).attr("class",
        textarea.attr("class")
      ).on("input",function(){
        $(this).prev("textarea").text($(this).text());
      })/*.on('keydown', function(e) {
			  var keyCode = e.keyCode || e.which;
			  if (keyCode == 9) {
			    e.preventDefault();

					$(this).prev("textarea").attr("value",$(this).text());
			  }
			})*//*.enableSmartTab()*/;
      textarea.css("display","none");
      $(this).append(input);
    }
  );
});

// File upload fields

$(function(){

	$("input[type=file].image, input[type=file].video").each(function(){
		var field = $(this);
		field.on('dragover dragenter', function() {
			$(this).addClass('drag_over');
		})
		.on('dragleave dragend drop', function() {
			$(this).removeClass('drag_over');
		});
	});


	$("input[type=file].image").each(function(){

		var field = $(this);

	  field.on('drop', function(e) {
			dropped_files = e.originalEvent.dataTransfer.files;
			if (!dropped_files[0].type.match(/image\/(.+)/)) {
				e.preventDefault();
				alert("Unsupported file type");
			}
	  }).on('change', function(e) {
			$(this).siblings("a.file_upload[name="+hashCode($(this).attr("data-array"))+"]").remove();
			$(this).siblings("div.file_preview").not("[name$='[]']").hide().find("textarea").text("");
			$(this).attr("data-label",e.target.files[0]["name"]);
			var link = $("<a class=\"file_upload light zoom\"></a>");
			var image = $("<img>");
			link.attr('href', URL.createObjectURL(e.target.files[0]));
			link.attr('name', hashCode($(this).attr("data-array")));
			image.attr('src', URL.createObjectURL(e.target.files[0]));
			link.append(image);
			$(this).before(link);
			Zoom5.parse();
	  });
	});

	$("input[type=file].video").each(function(){

		var field = $(this);

	  field.on('drop', function(e) {
			dropped_files = e.originalEvent.dataTransfer.files;
			if (!dropped_files[0].type.match(/video\/(.+)/)) {
				e.preventDefault();
			}
	  }).on('change', function(e) {
				field.siblings("a").remove();

				field.attr("data-label",e.target.files[0]["name"]);
				var link = $("<a class=\"file_upload light zoom\"></a>");
				var video = $("<video class=\"playhead\"></video>");
				var src = $("<source>");

				link.attr('href', URL.createObjectURL(e.target.files[0]));
				src.attr('src', URL.createObjectURL(e.target.files[0]))
				video.append(src);
				link.append(video);
				field.before(link);
				Zoom5.parse();
				Playhead.parse();

	  });
	});

});


// Dropdown checkbox
function dropdown(){
	$(".dropdown").each(function(){
		$(this).addClass("hide_children");
		$(this).wrapInner('<span class="child"></span>');
		$(this).click(function(){
			$(".dropdown").not($(this)).addClass("hide_children");
			$(this).toggleClass("hide_children");
		});
	});
}


// Smart Tabs in textareas
(function($) {
  $.fn.enableSmartTab = function() {
    var $this;
    $this = $(this);
    $this.keydown(function(e) {

      var after, before, end, lastNewLine, changeLength, re, replace, selection, start, val;
      if ((e.charCode === 9 || e.keyCode === 9) && !e.altKey && !e.ctrlKey && !e.metaKey) {
        e.preventDefault();
        start = this.selectionStart;
        end = this.selectionEnd;
        val = $this.val();
        before = val.substring(0, start);
        after = val.substring(end);
        replace = true;
				// console.log(start);
				// console.log(end);
        if (start !== end) {
					// console.log($(this));

          selection = val.substring(start, end);
          if (~selection.indexOf('\n')) {
            replace = false;
            changeLength = 0;
            lastNewLine = before.lastIndexOf('\n');
            if (!~lastNewLine) {
              selection = before + selection;
              changeLength = before.length;
              before = '';
            } else {
              selection = before.substring(lastNewLine) + selection;
              changeLength = before.length - lastNewLine;
              before = before.substring(0, lastNewLine);
            }
            if (e.shiftKey) {
              re = /(\n|^)(\t|[ ]{1,8})/g;
              if (selection.match(re)) {
                start--;
                changeLength--;
              }
              selection = selection.replace(re, '$1');
            } else {
              selection = selection.replace(/(\n|^)/g, '$1\t');
              start++;
              changeLength++;
            }
            $this.val(before + selection + after);
            this.selectionStart = start;
            this.selectionEnd = start + selection.length - changeLength;
          }
        }
        if (replace && !e.shiftKey) {
          $this.val(before + '\t' + after);
          this.selectionStart = this.selectionEnd = start + 1;
        }
      }
    });
		return $(this);
  };
})(jQuery);

function markown_fields() {

	elements = $("textarea.html_editor.markdown").not(".markdown_editor");
	elements.each(function(){

		$(this).addClass("markdown_editor");
		var styles = $(this).attr("style");

		var test = MarkdownEditor.create(this,{
			toolbar:["heading","bold","italic","bulletedList","numberedList","blockQuote","link","undo","redo"],
			language: $("html").attr("lang"),
			heading: {
				options: [
						{ model: "paragraph", title: "Paragraph", class: "ck-heading_paragraph" },
						{ model: "heading1", view: "h1", title: "Heading 1", class: "ck-heading_heading1" },
						{ model: "heading2", view: "h2", title: "Heading 2", class: "ck-heading_heading2" },
						{ model: "heading3", view: "h3", title: "Heading 3", class: "ck-heading_heading3" },
						{ model: "heading4", view: "h4", title: "Heading 4", class: "ck-heading_heading4" },
						{ model: "heading5", view: "h5", title: "Heading 5", class: "ck-heading_heading5" },
						{ model: "heading6", view: "h6", title: "Heading 6", class: "ck-heading_heading6" }
				]
			}
		})
		.then( editor => {
			var container = $(this).next("div");
			container.attr("style",styles);
			container.find(".ck-content").attr("style",styles);
		})
		.catch(error => {console.error(error);});
	});
}

function html_fields() {

	elements = $("textarea.html_editor").not(".markdown").not(".classic_editor");
	elements.each(function(){

		$(this).addClass("classic_editor");
		var styles = $(this).attr("style");

		ClassicEditor.create(this,{
			toolbar:["heading","bold","italic","bulletedList","numberedList","blockQuote","link","undo","redo"],
			language: $("html").attr("lang"),
			heading: {
				options: [
						{ model: "paragraph", title: "Paragraph", class: "ck-heading_paragraph" },
						{ model: "heading1", view: "h1", title: "Heading 1", class: "ck-heading_heading1" },
						{ model: "heading2", view: "h2", title: "Heading 2", class: "ck-heading_heading2" },
						{ model: "heading3", view: "h3", title: "Heading 3", class: "ck-heading_heading3" },
						{ model: "heading4", view: "h4", title: "Heading 4", class: "ck-heading_heading4" },
						{ model: "heading5", view: "h5", title: "Heading 5", class: "ck-heading_heading5" },
						{ model: "heading6", view: "h6", title: "Heading 6", class: "ck-heading_heading6" }
				]
			}
		})
		.then( editor => {
			$(this).next("div").attr("style",styles);
		})
		.catch(error => {console.error(error);});
	});
}

$(document).ready(function(){
	markown_fields();
	html_fields();
});



// Tabs in code form fields

$(document).ready(function(){
	document.querySelectorAll("div.code").forEach(function(item){
		item.addEventListener("keydown",function(){
			if(event.keyCode === 9){
	        event.preventDefault();
	        var range = window.getSelection().getRangeAt(0);

	        var tabNode = document.createTextNode("\u0009");
	        range.insertNode(tabNode);

	        range.setStartAfter(tabNode);
	        range.setEndAfter(tabNode);

	    }
		});
	});
});

// Output fields

$(document).ready(() => {

	document.querySelectorAll("output").forEach((item) => {
		var input = item.getAttribute("for");
		var input = document.querySelector("#"+input);

		input.addEventListener("input", () => {
			item.textContent = input.value;
		});

	});

});

