<?php

$core->template->backend->title(
	$core->language->translate(
		"Overview"
	)
);

$kits_available = $core->kit->installed(true);

foreach ($groups = $core->kit->data->group->read() as $index => $group) {

	// $kits = $core->kit->data->read(["group_ID" => key_of("ID", $group)]);
	$kits = $core->array->filter($kits_available, ["group_ID" => key_of("ID", $group)]);

	if (is_empty($kits)) {
		$groups = remove_keys_of($index, $groups);
		continue;
	}

	$content = [];

	$group_ID = key_of("ID", $group);

	if ($group["name"] == "System" && ($core->user->is_dev() || $core->config("global_kit_management")))
		$kits[] = array(
			"unique_name"=>"kits",
			"name"=>"Kits",
			"folder" => "kb_standard/kb_kits",
			"ID" => "kits",
			"run" => $core->json->encode(array("backend"=>true)),
			"icon" => "kb_kits.svg"
		);

	$start = false;

	if ($group["name"] == "Start") {
		$start = true;
		$groups[$index]["name"] = "";
	}

	if ($kits) {

		$default_icon = "/".$this->core->folder->path($this->core->path("url"),"core/template/images")."default_kit_icon.svg?version=".$core->file->age($this->core->path()."/core/template/images/default_kit_icon.svg");

		foreach ($kits as $kit_index => $value) {

			$core->kit->load(key_of("ID",$value));

			// $run = $core->json->decode(key_of("run", $value));

			// if (!key_of("backend", $run)) {
			if (is_empty(key_of("run", $value))) {
				$kits = remove_keys_of($kit_index,$kits);
				continue;
			}

			$key = key_of("ID", $value);

			if ($start) {

				$kit = $core->kit->load($key);

				$title = $core->html->tag(
					"h2",
					$core->language->translate(key_of("title",key_of("config",$kit)))
				);
				$kit = $core->html->tag("div", array($core->kit->run($kit)), array("class"=>"section"));
				$widget = $core->html->tag("div", array($kit), array("class"=>"kit kit-widget full_width auto_height"));
				$content[] = $core->html->render(array($title,$widget));

			}

			else {

				$icon_path = either(
					$core->kit->icon($value),
					$default_icon
				);

				$icon = $core->html->span("",[
					"class" => "icon",
					"style" => "background-image: url(".$icon_path.")"
				]);

				$name = key_of("name", $value);
				$name = $core->language->translate($name);
				$name = $core->html->h3($name, ["class" => "title"]);

				if ($info = key_of(array("info_text","description"),$value))
					$info = $core->language->translate($info);

				// $kit = $core->kit->load($key);

				if ($widget = $core->kit->widget(key_of("ID",$value))) {

					$link = "";

					if (key_of("link", $widget))
						$link = $core->html->a(
							[$icon, $name],
							[
								"class" => "kit_link",
								"href" => $core->url(["kit"=>key_of("ID",$value)], true),
								"title" => $info
							]
						);

					$widget_content  = $core->html->div(key_of("content", $widget), ["class"=>"kit_widget_content"]);

					$content[] = $core->html->div([$link,$widget_content], [
						"class"=>"kit_widget",
						"style" => "grid-column-start: span ".key_of(0, key_of("size", $widget))."; grid-row-start: span ".key_of(1, key_of("size", $widget)).""
					]);
				}

				else {

					$content[] = $core->html->a(
						[$icon, $name],
						[
							"class" => "kit_link",
							"href" => $core->url(["kit"=>key_of("ID",$value)], true),
							"title" => $info
						]
					);
				}
			}
		}

		$groups[$index]["kits"] = $kits;
		$groups[$index]["content"] = $content;
	}

}

// Run single Kit
if (not_empty($groups) && (count($groups) === 1) && (count($kits = key_of("kits", current((array) $groups))) === 1)) {
	$ID = key_fetch("ID", $kits);
	$core->set("kit", $ID);
	$core->template->backend->body(["class"=>"kit"]);
}

else if (not_empty($groups)) {


	/* Disable old home screen */

	if (!$start) {
		$group = current($groups);
		$ID = key_of("ID", $group);

		if (not_empty($ID))
			$core->refresh(["kitgroup"=>$ID]);
	}

	/* old home screen */

	foreach ($groups as $group) {
		if (not_empty(key_of("name", $group)) && count($groups) > 1)
			echo $core->html->render($core->html->h2(
				$core->html->a(
					$core->language->translate($group["name"]),
					["href" => $core->url(["kitgroup"=>key_of("ID", $group)],true)]
				)
			));
		if (not_empty($content = key_of("content", $group)))
			echo $core->html->div($content, ["class" => "kit_group"]);
	}
}

$core->template->backend->body(["class"=>"home"]);
