<?php

//Create Intance of Core Class
//Exit on failure

if(
	file_exists("../library/core.classes.php")
	&& (include("../library/core.classes.php"))
	&& $core = new KB_core("core")){}
else{
	header("HTTP/1.1 503 Service Unavailable");
	header("Status: 503 Service Temporarily Unavailable");
	exit(1);
}

$file = $core->path("root").$core->path("template").$core->get("icon", "get");

if (!$core->file->exists($file)) {
	if ($SERVER_PROTOCOL = key_of("SERVER_PROTOCOL", $_SERVER))
		header($SERVER_PROTOCOL." 404 Not Found");
	else
		header("HTTP/1.0 404 Not Found");
	exit(1);
}

$modified = $core->file->age($file);
$file = $core->file->read($file);

$color = $core->get("color");

if ($color)
	$file = $core->svg->property($file, "style","color:$color");

$color = either($color, "#000000");

/*
$file = $core->xml->render($core->xml->svg($file,[
	"xmlns" => "http://www.w3.org/2000/svg",
	"width" => "1em",
	"height" => "1em",
	"preserveAspectRatio" => "xMidYMid meet",
	"viewBox" => "0 0 24 24",
	"style" => ifttt($color, "color:$color", NULL)
]));
*/

$file = '<?xml version="1.0" encoding="UTF-8" standalone="no"?><!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN" "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">'.$file;

$color = hash("crc32", $color);
header('Etag: "'.$color.'"');
header("Last-Modified: ".kb_date("D, d M Y H:i:s", $modified)." GMT");
header('Content-type: image/svg+xml');
echo $file;
exit(0);
