<?php

if (
	are_equal($core->get("file"), "cancel")
){
	$kitbooth->folder->delete("restore");
	$core->refresh(["do"=>"edit","file"=>""]);
}

if (
	($file = $core->get("file")) &&
	$backup->file->exists($file) &&
	are_equal($backup->file->extension($file),"zip")
){
	$kitbooth->folder->delete("restore");
	$kitbooth->folder->create("restore");
	$kitbooth->file->unzip("backup/".$file,"restore");
	$core->refresh(["do"=>"edit","file"=>""]);
}

if (!$dir = $kitbooth->folder->read("restore"))
	$core->refresh(["do"=>""]);

$folder = "";

while ($dir) {

	if (in_array("kitbooth.sql", $dir))
		break;

	else {

		foreach($dir as $entry){
			if(is_dir($kitbooth->get_path("restore/".$folder.$entry))) {
				$folder .= $entry."/";
				$dir = $kitbooth->folder->read("restore/".$folder);
				break;
			}
		}
	}
}

$restore = $core->filesystem();
$restore->dir($restore->path($core->path(),"restore", $folder));

$form = $core->form();

$options = array(
	1 => "Replace with backup",
	2 => "Add missing and overwrite existing",
	3 => "Only add missing",
);

if ($restore->folder->read("", ["extension"=>"sql"])) {

	$form->new_element("case1", [
		"type"	=> "checkbox",
		"label"	=> "",
		"values"	=> [1=>"Database"],
		"value"	=> [1],
	]);

	$form->new_element("option1",array(
		"type"	=> "select",
		"label"	=> "",
		"values"	=> $options,
		"translate" => true,
	));
}
if(
	$restore->folder->exists("core") &&
	$restore->folder->exists("kits/kb_standard") &&
	$restore->file->exists("kitbooth.sql") &&
	$restore->file->exists(".htaccess")
){

	$form->new_element("case2", [
		"type"	=> "checkbox",
		"label"	=> "",
		"values"	=> [1=>"Kitbooth Core Installation"],
		"value"	=> [1],
	]);

	$form->new_element("option2", [
		"type"	=> "select",
		"label"	=> "",
		"values"	=> keys_of([1],$options),
		"value"	=> 1,
		"translate" => true,
	]);

}

if ($restore->folder->exists("kits")) {

	$form->new_element("case3", [
		"type"	=> "checkbox",
		"label"	=> "",
		"values"	=> [1=>"Kits"],
		"value"	=> [1],
	]);

	$form->new_element("option3", [
		"type"	=> "select",
		"label"	=> "",
		"values"	=> $options,
		"translate" => true,
	]);
}

if ($restore->folder->exists("frontend/templates")) {

	$form->new_element("case4", [
		"type"	=> "checkbox",
		"label"	=> "",
		"values"	=> [1=>"Templates"],
		"value"	=> [1],
	]);
	$form->new_element("option4", [
		"type"	=> "select",
		"label"	=> "",
		"values"	=> $options,
		"translate" => true,
	]);
}

if ($restore->folder->exists("frontend/content")) {

	$form->new_element("case5", [
		"type"	=> "checkbox",
		"label"	=> "",
		"values"	=> [1=>"Website content"],
		"value"	=> [1],
	]);

	$form->new_element("option5", [
		"type"	=> "select",
		"label"	=> "",
		"values"	=> $options,
		"translate" => true,
	]);
}

if ($restore->folder->exists("frontend/files")) {

	$form->new_element("case6", [
		"type"	=> "checkbox",
		"label"	=> "",
		"values"	=> [1=>"Files"],
		"value"	=> [1],
	]);

	$form->new_element("option6", [
		"type"	=> "select",
		"label"	=> "",
		"values"	=> $options,
		"translate" => true,
	]);
}


$form->new_element("submit",array(
	"type"	=> "submit",
	"value"	=> "Wiederherstellen",
	"markup"	=> 'class="green"',
));


if ($form->submit()){

	//Data base
	if ($form->value("case1")) {

		$sql_file = $restore->folder->read("",["extension"=>"sql"]);
		$sql_file = $restore->filesystem->get_path($sql_file[0]);

		switch ($form->value("option1")) {

			// Replace
			case 1:

				$db_data = $core->get_config('db');
				$mb = exec('mysql --user='.$db_data['user'].' --password='.$db_data['password'].' -h '.$db_data['server'].' -D '.$db_data['database'].' < '.$sql_file, $out, $ret);
				break;

			// Fill and Overwrite
			case 2:

				$sql = "SHOW TABLES";
				$result = $core->db->sql_all($sql);

				foreach($result as $value)
					$tables_old[] = current($value);

				$UID = time();

				$sql = "SET FOREIGN_KEY_CHECKS=0;";
				$core->db->query($sql);

				foreach($tables_old as $table) {
					$sql = "RENAME TABLE ".$table." TO ".$table."_".$UID;
					$core->db->query($sql);
				}

				$db_data = $core->get_config('db');

				$exec = 'mysql --user='.$db_data['user'].' --password='.$db_data['password'].' -h '.$db_data['server'].' -D '.$db_data['database'].' < '.$sql_file;
				$mb = exec($exec, $out, $ret);

				$sql = "SHOW TABLES";
				$result = $core->db->sql_all($sql);

				foreach($result as $value)
					if(!preg_match("/_".$UID."/",current($value)))
						$tables_new[] = current($value);

				foreach($tables_old as $table)
					if(!in_array($table,$tables_new))
						$tables_missing[] = $table;

				foreach($tables_missing as $table){
					$sql = "RENAME TABLE ".$table."_".$UID." TO ".$table;
					$core->db->query($sql);
				}

				foreach ($tables_new as $table) {

					$sql = "CREATE TEMPORARY TABLE ".$table."_new SELECT * FROM ".$table;
					$core->db->query($sql);

					$sql = "TRUNCATE TABLE ".$table;
					$core->db->query($sql);

					$sql = "INSERT IGNORE INTO ".$table." SELECT * FROM ".$table."_new UNION SELECT * FROM ".$table."_".$UID;
					$core->db->query($sql);
				}

				foreach ($tables_old as $table) {
					if(!in_array($table,$tables_missing)){
						$sql = "DROP TABLE ".$table."_".$UID;
						$core->db->query($sql);
					}
				}

				$sql = "SET FOREIGN_KEY_CHECKS=1";
				$core->db->query($sql);
				break;

			// Fill
			case 3:

				$sql = "SHOW TABLES";
				$result = $core->db->sql_all($sql);

				foreach($result as $value)
					$tables_old[] = current($value);

				$UID = time();

				$sql = "SET FOREIGN_KEY_CHECKS=0;";
				$core->db->query($sql);

				foreach($tables_old as $table){
					$sql = "RENAME TABLE ".$table." TO ".$table."_".$UID;
					$core->db->query($sql);
				}

				$db_data = $core->get_config('db');

				$exec = 'mysql --user='.$db_data['user'].' --password='.$db_data['password'].' -h '.$db_data['server'].' -D '.$db_data['database'].' < '.$sql_file;
				$mb = exec($exec, $out, $ret);

				$sql = "SHOW TABLES";
				$result = $core->db->sql_all($sql);

				foreach ($result as $value)
					if (!preg_match("/_".$UID."/",current($value)))
						$tables_new[] = current($value);

				foreach ($tables_old as $table)
					if(!in_array($table,$tables_new))
						$tables_missing[] = $table;

				foreach ($tables_missing as $table) {
					$sql = "RENAME TABLE ".$table."_".$UID." TO ".$table;
					$core->db->query($sql);
				}

				foreach ($tables_new as $table) {

					$sql = "CREATE TEMPORARY TABLE ".$table."_new SELECT * FROM ".$table;
					$core->db->query($sql);

					$sql = "TRUNCATE TABLE ".$table;
					$core->db->query($sql);

					$sql = "INSERT IGNORE INTO ".$table." SELECT * FROM ".$table."_".$UID." UNION SELECT * FROM ".$table."_new";
					$core->db->query($sql);
				}

				foreach($tables_old as $table){
					if(!in_array($table,$tables_missing)){
						$sql = "DROP TABLE ".$table."_".$UID;
						$core->db->query($sql);
					}
				}

				$sql = "SET FOREIGN_KEY_CHECKS=1";
				$core->db->query($sql);
				break;
		}
	}

	// Kitbooth Core
	if ($form->value("case2")) {

		//Data base

		$sql_file = $restore->get_path("kitbooth.sql");
		$db_data = $core->get_config('db');
		$mb = exec('mysql --user='.$db_data['user'].' --password='.$db_data['password'].' -h '.$db_data['server'].' -D '.$db_data['database'].' < '.$sql_file, $out, $ret);

		//Core Folder

		$kitbooth->folder->copy(
			"restore/".$folder."/core",
			"",
			$option
		);

		//Standard Kits

		$kitbooth->folder->copy(
			"restore/".$folder."/kits/kb_standard",
			"kits",
			$option
		);

	}

	// Kits
	if ($form->value("case3")) {

		switch ($form->value("option3")) {

			// Replace
			case 1:
				$option = ["merge" => false];
				break;

			// Fill and Overwrite
			case 2:
				$option = [];
				break;

			// Fill
			case 3:
				$option = ["overwrite" => false];
				break;
		}
		$kitbooth->folder->copy(
			"restore/".$folder."/kits",
			"",
			$option
		);

	}

	// Templates
	if(!empty($form->values["case4"])){

		switch ($form->values["option4"]){

			// Replace
			case 1:
				$option = ["merge" => false];
				break;

			// Fill and Overwrite
			case 2:
				$option = [];
				break;

			// Fill
			case 3:
				$option = ["overwrite" => false];
				break;
		}
		$kitbooth->folder->copy(
			"restore/".$folder."/frontend/templates",
			"frontend",
			$option
		);
	}

	// Content
if ($form->value("case5")) {

		switch ($form->value("option5")) {

			// Replace
			case 1:
				$option = ["merge" => false];
				break;

			// Fill and Overwrite
			case 2:
				$option = [];
				break;

			// Fill
			case 3:
				$option = ["overwrite" => false];
				break;
		}
		$kitbooth->folder->copy(
			"restore/".$folder."/frontend/content",
			"frontend",
			$option
		);
	}

	// Files
	if ($form->value("case6")) {

		switch ($form->value("option6")) {

			// Replace
			case 1:
				$option = ["merge" => false];
				break;

			// Fill and Overwrite
			case 2:
				$option = [];
				break;

			// Fill
			case 3:
				$option = ["overwrite" => false];
				break;
		}
		$kitbooth->folder->copy(
			"restore/".$folder."/frontend/files",
			"frontend",
			$option
		);
	}


	$kitboth->folder->delete("restore");
	$core->refresh(["kit"=>$core->get("kit"),"view" => "restore"],true);
}
echo $core->html->div([
	$core->html->h3("Restore"),
	$core->html->h2($core->folder->name($folder)),
	$core->html->h3("Restore options"),
	$form->render_form(true),
	$core->html->a("Cancel",["class"=>"button","href"=>$core->url(["do"=>"edit","file"=>"cancel"])]),
]);
