<?php
if (are_equal($core->get("do"), "config_export")) {

	$core->filesystem->write(
		$core->kit->current["url"]."setup.json",
		$core->json->encode($config)
	);

	$core->message->info("Settings have been saved.");
	$core->refresh(["do"=>"config"]);
}

$form = $core->form();

if ($data->group)
	$form->new_elements(
		[
			"group_properties" => [
			  "label" => "Group specific properties",
			  "value" => key_of("group_properties",key_of("options", $config)),
			  "values" => [""=>"No","1"=>"Yes"],
				"type" => "radio"
			],
			"data_title" => [
			  "label" => "Data title",
			  "value" => key_of("data_title",key_of("options", $config)),
			],
			"group_title" => [
		  	"label"  => "Group title",
				"value" => key_of("group_title",key_of("options", $config)),
			]
		]
	);

$rights_values = $core->user->group->read_column("name")+['0'=>$core->language->translate("No one")];

$form->new_elements(
	[
		"display" => [
			"label" => "Display",
			"type" => "checkbox",
			"class"  => "dropdown",
			"value" => key_of("display",key_of("options", $config)),
			"values" => [
				"set_pagination" => "Set Pagination",
				"search" => "Search",
				"import_export" => "Import/Export",
				"archiving" => "Archiving",
			],
		],
		"rights_edit" => [
		  "label"  => "Edit",
		  "type"  => "checkbox",
		  "class"  => "dropdown",
		  "value" => key_of("edit",key_of("rights", $config)),
		  "values" => $rights_values,
			"markup" => 'style="min-width: 10em"',
		],
		"rights_config" => [
		  "label"  => "Configure",
		  "type"  => "checkbox",
		  "class"  => "dropdown",
			"value" => key_of("config",key_of("rights", $config)),
			"values" => $rights_values,
		],
		"rights_export" => [
		  "label"  => "Export",
		  "type"  => "checkbox",
		  "class"  => "dropdown",
			"value" => key_of("export",key_of("rights", $config)),
			"values" => $rights_values,
		],
		"rights_edit_properties" => [
		  "label"  => "Change data fields",
		  "type"  => "checkbox",
		  "class"  => "dropdown",
			"value" => key_of("edit_properties",key_of("rights", $config)),
			"values" => $rights_values,
		],
		"rights_edit_layout" => [
		  "label"  => "Change edit layout",
		  "type"  => "checkbox",
		  "class"  => "dropdown",
			"value" => key_of("edit_layout",key_of("rights", $config)),
			"values" => $rights_values,
		],
		"rights_overview_properties" => [
		  "label"  => "Change overview fields",
		  "type"  => "checkbox",
		  "class"  => "dropdown",
			"value" => key_of("overview_properties",key_of("rights", $config)),
			"values" => $rights_values,
		],
		"currency"	=> [
  		"label"  => "Currency",
			"value" => key_of("currency",key_of("options", $config)),
		],
		"save" => [
		  "type"  => "submit",
		  "value" => "Save",
		  "class"	=> "green",
		]
	]
);

if ($form->submit()) {

	$core->config("options",[
		"group_properties" => $form->value("group_properties"),
		"data_title" => $form->value("data_title"),
		"group_title" => $form->value("group_title"),
		"display" => $form->value("display"),
		"currency" => $form->value("currency"),
	]);

	$core->config("rights",[
		"edit" => $form->value("rights_edit"),
		"config" => $form->value("rights_config"),
		"export" => $form->value("rights_export"),
		"edit_properties" => $form->value("rights_edit_properties"),
		"edit_layout" => $form->value("rights_edit_layout"),
		"overview_properties" => $form->value("rights_overview_properties"),
	]);

	$core->message->info();
	$core->refresh();

}

echo $core->template->kit->panel(
	"Settings",
	$core->template->kit->tabs([
		$core->language->translate("General") => $form->render([
			"display",
			"group_properties",
			"data_title",
			"group_title",
			"currency"
		]),
		$core->language->translate("Rights") => $form->render([
			"rights_edit",
			"rights_config",
			"rights_export",
			"rights_edit_properties",
			"rights_edit_layout",
			"rights_overview_properties"
		]),
	]),
	[
		$form->field("save"),
		$core->template->kit->button("Export", ["href" => $core->url(["do"=>"config_export"])]),
		$core->template->kit->button("Close", ["href" => $core->url(["do"=>""])]),
	],
	[
		"wrap_form" => $form,
		"footer" => ["class" => "fill flex"]
	]
);
