<?php

$layout_properties = $get_config("edit_layout");
$edit_properties = $get_config("edit_properties");

if ($data->group && !array_find(array("type"=>"group_ID"),$edit_properties))
	$edit_properties["group_ID"] = [
		"label" => $core->language->translate("Group"),
				"key" => "group_ID",
			];

if ($data->position() && !array_find(array("type"=>"position"),$edit_properties))
	$edit_properties["position"] = [
		"label" => $core->language->translate("Position"),
				"key" => "position",
			];

$columns = array(NULL=>"");

if ($edit_properties)
	foreach($edit_properties as $column => $property)
		$columns[$column] = $property["label"];

$form = $core->form();

$form->new_element("save", array(
	"label" => "Save",
	"type" => "submit",
	"class" => "green",
));

$tab_form_fields = function ($properties, $tab) use ($form, $columns) {

	$section = 0;
	$column = 0;

	if (not_empty($properties))
		foreach ($properties as $section => $section_properties) {

			foreach($section_properties as $column => $column_properties){

				$form->new_element("f_".$tab."_".$section."_".$column."_label", array(
					"markup" => 'style="width:100%"',
					"value" => fetch("label",$column_properties),
				));

				$form->new_element("f_".$tab."_".$section."_".$column."_options", array(
					"type" => "checkbox",
					"class" => "dropdown",
					"value" => array(fetch("options",$column_properties),array("array"=>"duplicate column")),
				));

				$form->new_element("f_".$tab."_".$section."_".$column."_fields", array(
					"array" => true,
					"type" => "select",
					"value" => either(
						fetch("fields",$column_properties),
						array("")
					),
					"values" => $columns
				));
			}

		$form->new_element("f_".$tab."_".$section."_".($column+1)."_label", array(
			"placeholder" => "New Column",
		));

		$form->new_element("f_".$tab."_".$section."_".($column+1)."_fields", array(
			"type" => "hidden",
		));

		$form->new_element("f_".$tab."_".$section."_".($column+1)."_options", array(
			"type" => "checkbox",
			"class" => "dropdown",
			"value" => array("",array("array"=>"duplicate column")),
		));
	}

	else
		$section = -1;

	$form->new_element("f_".$tab."_".($section+1)."_0_label", array(
		"placeholder" => "New Row",
	));

};

// Create form without tabs
if (is_indexed($layout_properties) || is_empty($layout_properties)) {

	$tab_form_fields($layout_properties, 0);

	$form->new_element("f_tab_0_label", array(
		"placeholder" => "Tab",
	));

}

// Create form with tabs
else {

	$i = 0;

	foreach ($layout_properties as $tab => $tab_properties){

		$form->new_element("f_tab_".$i."_label", array(
			"value" => $tab,
		));

		$tab_form_fields($tab_properties, $i);

		$i++;
	}

	$tab_form_fields(array(),$i);
	$form->new_element("f_tab_".($i)."_label", array(
		"placeholder" => "New Tab",
	));
	}

// Execute Form

if ($form->submit()) {

	$values = $form->values();

	foreach ($values as $key => $value) {

		preg_match_all("/^f_(\w)_(\w)_(\w)_(\w+)/",$key, $matches);

		if (any_empty($matches[1], $matches[2], $matches[3], $matches[4]))
			continue;

		if (is_empty($value))
			continue;

		$matches[1][0] = either(
			$form->value("f_tab_".$matches[1][0]."_label"),
			$matches[1][0]
		);

		$values_sorted[$matches[1][0]][$matches[2][0]][$matches[3][0]][$matches[4][0]] = $value;
	}

	if (is_indexed($values_sorted))
		$values_sorted = $values_sorted[0];

	/*
	if (!empty($edit_group_properties) && ($group_ID))
		$layout_properties[$group_ID] = $values_sorted;

	else
		$layout_properties = $values_sorted;

	*/

	/*
	$core->config(
		$group_config_name."edit_".$edit_group_layout."layout",
		$layout_properties
	);
	*/

	$set_config("edit_layout",$values_sorted);

	$core->refresh();

}


// Output

$tab_table_fields = function ($layout_properties, $tab) use ($form, $core) {

	$content = "";

	if(not_empty($layout_properties))
		foreach($layout_properties as $section => $section_properties){

			$table = $core->table();

			unset($array);

			foreach($section_properties as $column => $column_properties){
				$table->new_element("t_".$tab."_".$column, array(
					"title" => $form->field("f_".$tab."_".$section."_".$column."_label")."<br>".$form->field("f_".$tab."_".$section."_".$column."_options"),
					"sort" => false,
				));
				$array[0]["t_".$tab."_".$column] = $form->field("f_".$tab."_".$section."_".$column."_fields");
			}

			$array[0]["t_".$tab."_".($column+1)] = $form->field("f_".$tab."_".$section."_".($column+1)."_fields");

			$table->new_element("t_".$tab."_".($column+1), array(
				"title" => $form->field("f_".$tab."_".$section."_".($column+1)."_label")."<br>".$form->field("f_".$tab."_".$section."_".($column+1)."_options"),
				"sort" => false,
			));

			$table->new_element("t_".$tab."_".$column, array(
				"title" => $form->field("f_".$tab."_".$section."_".$column."_label")."<br>".$form->field("f_".$tab."_".$section."_".$column."_options"),
				"sort" => false,
			));

			// if(not_empty($array))
				$content .= $table->render($array);

		}

	$table = $core->view->table();

	$table->new_element("t_0", array(
		"title" => $form->field("f_".$tab."_".(isset($section) ? $section+1 : 0)."_0_label"),
		"sort" => false,
	));

	$content .= $table->render(array());
	return $content;
};

// Create output without tabs
if (is_indexed($layout_properties) || is_empty($layout_properties)) {

	$content = $tab_table_fields($layout_properties, 0);

	$content = $core->template->kit->tabs(
		array(
			array(
				$form->field("f_tab_0_label"),
				$content
			)
		)
	);

}

// Create output with tabs
else {

	$array = array();
	$i = 0;

	if (not_empty($layout_properties))
		foreach ($layout_properties as $tab => $tab_properties) {
			$array[$form->field("f_tab_".$i."_label")] = $tab_table_fields($tab_properties, $i);
			$i++;
		}

	$array[$form->field("f_tab_".$i."_label")] = $tab_table_fields(array()/*$tab_properties*/, $i);

	$content = $core->template->kit->tabs(
		$array
	);
}

// Output panel
$title = "Edit Form Layout";

$cancel = $core->template->kit->button("Close", array("class"=>"cancel button", "href" => $core->url(array("do"=>"edit_properties"))));

echo $core->template->kit->panel(
	$title,
	$content,
	array($form->field("save"),$cancel),
	array("wrap_form"=>$form, "footer" => array("class"=>"fill flex"))
);
