<?php

/*
Case: Do once
interval is NULL

start when next is empty
stop when next is past
dont change cron
*/

/*
Case: Do every time
interval is 0

start everytime
set next to current time
set cron to now
stop never
*/

/*

Case: Do in interval
interval is positive

start when next is past time
set next to next plus interval
set cron to next
stop never

*/

$run = function ($ID = "", $options = [], $user = NULL) use($core) {

	if (any_empty($ID, $user, is_numeric($ID), is_numeric($user)))
		return false;

	$new_core = new KB_Core("cron");
	$new_core->user->login($user);
	$kit = $new_core->kit->installed($ID,"backend");

	if (is_empty($kit))
		return false;

	if (not_empty($options) && is_array($options))
		foreach ($options as $key => $value) {
			$core->set($key, $value);
		}

	return $core->kit->run($kit, $options);
};


$calc_timer = function ($time = "", $interval = "") use (&$calc_timer) {

	if (any_empty($time, $interval))
		return $time;

	$time = int(kb_date("U", $time));
	$time += int($interval);

	if ($time < int(kb_date("U")))
		$time = $calc_timer($time, $interval);

	return $time;

};


$cron = function () use($core, $kit, $run, $calc_timer, $data) {

	$timer = $core->config("cron");

	if (are_equal($timer,0))
		return false;

	if (int($timer) > int(kb_date("U")))
		return false;

	$new_timer = 0;
	$entries = $data->read(array("active"=>"1"));

	foreach ($entries as $entry) {

		if (is_null($interval = key_of("interval", $entry))) {

			if (key_of("next", $entry))
				continue;

			$data->update(array(
				"ID" => key_of("ID", $entry),
				"next" => "NOW()"
			));
		}

		else {

			$next_timer = kb_date("U",either(key_of("next", $entry), key_of("start", $entry)));

			if ($new_timer === 0 || $new_timer > $next_timer)
				$new_timer = $next_timer;

			if (int(kb_date("U", key_of("next", $entry))) > int(kb_date("U")))
				continue;

			$next_timer = $calc_timer($next_timer, $interval);

			$run(key_of("kit", $entry), $core->json->decode(key_of("command", $entry)),key_of("user", $entry));

			$data->update(array(
				"ID" => key_of("ID", $entry),
				"next" => kb_date("Y-m-d H:i:s",$next_timer)
			));

		}
	}

	return $new_timer;
};


$next = $cron();

if ($next !== false)
	$core->config("cron", $next);
