<?php
$form = $core->form();
$core_tables = array_values($core->array->sort(array_keys($data->tables())));
$table_o = $core->data();
$columns = [];

if (not_empty($object_columns = $object->columns()))
	$columns = array_combine(
			array_keys($object_columns),
			array_keys($object_columns)
	);

$properties = $get_config("edit_properties");


if (is_empty($properties)) {

	if (not_empty(array_keys((array)$columns))) {

		foreach ($columns as $key => $value)
			$properties[] = array(
				"key" => $key,
				"label" => $key,
			);
	}

	else if (is_array($object->auto_create) && not_empty($object->auto_create)) {

		foreach ($object->auto_create as $key => $value) {

			if (is_numeric($key))
				$key = $value;

			$properties[] = array(
				"key" => $key,
				"label" => $key,
			);
		}
	}
}

$i = 0;

foreach ((array)$properties as $key => $property) {


	$type = "text";
	$value = $property["key"];

	$form->new_elements(array(

		"label_".$i => array(
			"label"	=> "",
			"value"	=> $property["label"]
		),

		"key_".$i => array(
			"label"	=> "",
			"type"	=> ifttt(($object->properties() || $object->expandable()), "text" , "select"),
			"value"	=> ifttt(($object->properties() || $object->expandable()), $value , array($value,$columns)),
			// "disabled" => ifttt(($object->properties || $object->expandable), false , true),
		),

		"type_".$i => array(
			"label"	=> "",
			"type"	=> "select",
			"translate" => true,
			"value"	=> key_of("type", $property),
			"values" => array_combine(
					$core->array->implode($input_types,"type"),
					$core->array->implode($input_types,"label")
			),
		),
	));

	$type = "hidden";
	$value = "";
	$values = array();
	$label= "";

	if (isset($property["type"])) {

		if (fetch("select",$property["type"]) || fetch("radio",$property["type"]))
			$type =  "text";

		if (in_array(key_fetch("type", $property), array("date", "datetime-local", "foreign", "correlation")))
			$type = "select";

		if (fetch("select",$property["type"]) || fetch("radio",$property["type"])){
			$value =  either($core->json->decode(key_of("values", $property)), "");
			$label = "Values:";
		}

		else if (fetch("date",$property["type"]) || fetch("datetime-local",$property["type"])){
			$array = array("","NOW"=>"Heute");
			$value =  isset($property["values"]) ? array($property["values"],$array) : array("",$array);
			$label = "Default value:";
		}

		else if ($property["type"] == "correlation" || $property["type"] == "foreign"){
			$value = key_fetch(0, key_fetch("values", $property));
			$values = $core_tables;

			if ($property["type"] == "correlation")
				$label = "with:";
			else
				$label = "From:";
		}
	}

	$form->new_element('values_'.$i."_1",array(
		"label"	=> $label,
		"type"	=> $type,
		"markup"	=> 'style="width:10em"',
		"value"	=> $value,
		"values"	=> $values,
	));

	$type = "hidden";
	$value = "";
	$label= "";

	if (isset($property["type"])) {

			if ($property["type"] == "correlation" || $property["type"] == "foreign"){

				$type = "select";

				if (is_empty(key_of("values",$property))) {
					$value = array($key,array());
				}

				else {

					if(is_array($property["values"]) && not_empty($property["values"][0])){
						// $table = $core_tables_o->entry(array("name"=>$property["values"][0]));
						$table_o->db_table($property["values"][0]);
						$table = array_keys($table_o->columns());


						if(is_empty($key = $property["values"][1]))
							$key = "";

						$value = array($key,$table);
					}
				}
				$label = "Value:";
			}
	}

	$form->new_element('values_'.$i."_2",array(
		"label"	=> $label,
		"type"	=> $type,
		"value"	=> $value,
	));


	if (fetch("correlation",key_fetch("type",$property)) || fetch("foreign",key_fetch("type",$property))) {
		$type = "select";
		$array = array(""=>"");
		$values_1 = $array+$filter_options;
		$value_1 =  isset($property["filter"]) ? key($property["filter"]) : "";

		if(isset($property["values"]) && is_array($property["values"]) && not_empty($property["values"][0])){

			if(preg_match("/_group/",$property["values"][0])){
				$filter_table = $core->data_group($property["values"][0]);
				$filter_table->order("name");
				$filter_table->group = false;
			}

			else{
				$akin = $core->data($property["values"][0]);
				$filter_table = $core->data_group($akin);

				if (!key_of("parent_ID", $filter_table->columns()))
					$filter_table->group = false;
			}

			$array = array();

			if (not_empty($property["values"][1]))
				$values_2 = array(""=>"")+$filter_table->read_column($property["values"][1],array(
					"spacing" => "&nbsp;&nbsp;&nbsp;",
				));
		}
		$value_2 =  isset($property["filter"]) ? current($property["filter"]) : "";
	}
	else {
		$type = "hidden";
		$value_1 = "";
		$values_1 = array();
		$value_2 = "";
		$values_2 = array();
	}

	$form->new_element('filter_option_'.$i,array(
			"label"	=> "",
			"type"	=> $type,
			"value"	=> $value_1,
			"translate" => true,
			"values"	=> $values_1,
	));

	$form->new_element('filter_'.$i,array(
			"label"	=> "",
			"markup"	=> 'style="width:10em"',
			"type"	=> $type,
			"value"	=> $value_2,
			"values"	=> $values_2,
	));

	$options = [];

	$options = $core->array->merge(
		key_fetch("all",$input_options),
		either(
			key_fetch(key_fetch("type",$property),$input_options),
			array()
		)
	);


	$value =  isset($property["options"]) ? array($property["options"],$options) : array("",$options);

	$form->new_element('options_'.$i,array(
		"label"	=> "",
		"type"	=> "checkbox",
		"value"	=> $value,
		"class" => "dropdown",
	));

	$value =  isset($property["style"]) ? $property["style"] : "";

	$form->new_element('style_'.$i,array(
			"label"	=> "",
			"value"	=> $value,
	));

	$i++;
}


$form->new_elements(array(

	'label_'.$i => array(
		"label"	=> "",
	),

	'key_'.$i => array(
		"label"	=> "",
		"type"	=> ifttt(($object->properties() || $object->expandable()), "text" , "select"),
		"value"	=> ifttt(($object->properties() || $object->expandable()), "" , array("",$columns)),
	),

	'type_'.$i => array(
		"label"	=> "",
		"type"	=> "select",
		"translate" => true,
		"values"	=> array_combine(
			$core->array->implode($input_types,"type"),
			$core->array->implode($input_types,"label")
		)
	),

	'values_'.$i."_1" => array(
		"label"	=> "",
		"markup"	=> 'style="width:10em"',
		"type"	=> "hidden",
		"value"	=> "",
	),

	'values_'.$i."_2" => array(
		"label"	=> "",
		"type"	=> "hidden",
		"value"	=> "",
	),

	'filter_option_'.$i => array(
		"label"	=> "",
		"type"	=> "hidden",
		"value"	=> "",
	),

	'filter_'.$i => array(
		"label"	=> "",
		"markup"	=> 'style="width:10em"',
		"type"	=> "hidden",
		"value"	=> "",
	),

	'options_'.$i => array(
		"label"	=> "",
		"type"	=> "hidden",
		"value"	=> "",
	),

	'style_'.$i => array(
		"label"	=> "",
		"type"	=> "hidden",
		"value"	=> "",
	)
));

$i++;

$table = $core->view->table();
$table->config("sort",false);
$table->pagination = false;

$table->new_columns(array(

	"label" => array(
		"title"	=> "Label",
	),

	"key" => array(
		"title"	=> ifttt($object->properties, "Database key name (optional)", "Database column"),
	),

	"type" => array(
		"title"	=> "Data type",
	),

	"values" => array(
		"title"	=> "Values",
	),

	"filter" => array(
		"title"	=> "Filter",
		"collapsible"	=> true,
	),

	"options" => array(
		"title"	=> "Options",
		"collapsible"	=> "collapsed",
	),

	"style" => array(
		"title"	=> "Style",
		"collapsible"	=> "collapsed",
	),
));



$form->new_element("save", array(
	"label"	=> "Save",
	"type"	=> "submit",
	"class"	=> "green",
));


if ($form->submit()) {

	$properties = array();

	// unset($form->values["save"]);

	for ($n = 0; $n < $i; $n++){

		$key = $form->value("key_".$n);

		if (key_of("disabled", $form->element["key_".$n]))
			$key = key_of("value", $form->element["key_".$n]);

		$value = $form->value("label_".$n);

		if ($value) {

			if (is_empty($key))
				$key = db_encode($value);

			$add = [
				"label"	=> $value,
				"key"	=> $key,
				"type" => $text,
			];

			if (not_empty($type = $form->value("type_".$n)))
				$add["type"] = $type;

			if (not_empty($values = $form->value("values_".$n."_1"))){

				if (in_list($add["type"], ["select","radio"]))
					$add["values"] = either($core->json->decode($values), []);

				else if (in_list($add["type"], ["date","datetime-local"]))
					$add["values"] = $values;

				else if(in_list($add["type"], ["correlation", "foreign"]))
					$add["values"] = [$values, $form->value("values_".$n."_2")];
			}

			if (not_empty($filter_option = $form->value("filter_option_".$n)) && not_empty($filter = $form->value("filter_".$n)))
				$add["filter"] = [$filter_option => $filter];

			if (not_empty($options = $form->value("options_".$n)))
				$add["options"] = $options;

			if(not_empty($style = $form->value("style_".$n)))
				$add["style"] = $style;

			$properties[] = $add;
		}
	}

	$set_config("edit_properties",$properties);
	// die();

	$core->refresh();
}

$array = $form->render_as_array();



foreach($array as $key => $entry)
{
	if($key%9==0)
	{
		$array[$key]["label"] = $array[$key]["field"];
		$array[$key]["key"] = $array[$key+1]["field"];
		$array[$key]["type"] = $array[$key+2]["field"];
		$array[$key]["values"] = "<div>".$array[$key+3]["label"].$array[$key+3]["field"].$array[$key+4]["label"].$array[$key+4]["field"]."</div>";
		$array[$key]["filter"] = $array[$key+5]["field"].$array[$key+6]["field"];
		$array[$key]["options"] = $array[$key+7]["label"].$array[$key+7]["field"];
		$array[$key]["style"] = $array[$key+8]["label"].$array[$key+8]["field"];
		unset($array[$key]["field"]);
		unset($array[$key+1]);
		unset($array[$key+2]);
		unset($array[$key+3]);
		unset($array[$key+4]);
		unset($array[$key+5]);
		unset($array[$key+6]);
		unset($array[$key+7]);
		unset($array[$key+8]);
	}
}


$table_menu = array(
	"edit_layout" => array(
		"title" => "Data Entry Layout",
		"class" => "small button"
	)
);

echo $core->template->kit->panel(

	"Data Fields",

	array(
		$core->template->kit->table_menu($table_menu),
		$table->render($array),
	),

	array(
		$form->field("save"),
		$core->template->kit->button("Close", array(
			"href" => $core->url(array("do"=>"edit")),
			"class" => "cancel button",

		))
	),

	array("wrap_form"=>$form, "footer" => array("class" => "fill flex"))
);
$core->template->backend->head(
	$core->template->backend->css($kit["path"]."backend/style.css")
);
