<?php

if (is_empty($file = $core->get("file")))
	return;

$folder_values = function($array = [], $prefix = "") use ($core, &$folder_values) {

	$return = [];

	if (!is_array($array) || is_empty(array_keys($array)))
		return false;

	foreach ($array as $key => $value) {

		$return[] = $prefix.$key."/";

		$return = $core->array->union($return, $folder_values($value, $key."/"));

	}

	return $return;

};


$folders = $folder_values($core->filesystem->read($core->path("root","frontend"),["type"=>"folder","recursive"=>true]));

$core->filesystem->dir($core->path("frontend").$core->get("folder"));

$form = $core->form();

$form->new_fields([
	"name" => [
		"required" => true,
		"label" => "Name",
	],
	"folder" => [
		"label" => "Folder",
		"type" => "select",
		"values" => $folders,
	],
	"submit" => [
		"type" => "submit"
	]
]);

if (fetch($core->file->extension($file), ["css","js","txt","md"]))
	$form->new_fields([
		"type" => [
			"type" => "select",
			"values" => ["css","js","txt","md"],
			"label" => "Type",
		],
		"content" => [
			"type" => "textarea",
			"class" => "code",
			"label" => "Content",
		],
	]);

$form->values([
	"name" => $core->file->basename($file),
	"type" => $core->file->extension($file),
	"content" => $core->file->read($file),
	"folder" => $core->get("folder"),
]);

if ($form->submit()) {

	if (!are_equal($form->value("folder"), $core->get("folder"))) {
		$core->file->move($file, $core->path("root","frontend").$form->value("folder").$file);
		$core->filesystem->dir($core->path("frontend").$form->value("folder"));
	}

	if (!is_null($form->value("content")))
		$core->file->write($file, $form->value("content"));

	if ($form->value("type"))
		$core->file->name($file, $form->value("name").".".$form->value("type"));

	else
		$core->file->name($file, $form->value("name").".".$core->file->extension($file));

	$core->refresh(["do"=>"","file"=>""]);

}

echo $core->template->kit->panel(
	"Edit",
	$form->render(false),
	[
		$form->field("submit"),
		$core->template->kit->button("Cancel", ["href"=>$core->url(["do"=>""])])
	],
	[
		"wrap_form" => $form,
		"footer" => ["class"=>"fill flex"]
	]
);