<?php

$ID = $core->get("ID");

$entry = $core->kit->data->entry($ID);
$position = $core->kit->data->dropdown_position($ID);
$kit_config = $core->kit->load($ID,"kit_config");

if ($core->user->is_dev()){

	$kit_o = $core->data("kb_kit");
	$kit_o->position(true);
	$kit_o->group(true);
	$entry = $kit_o->entry($ID);
	$position = $kit_o->dropdown_position($ID);

}

$sharing = $core->user->group->correlates($core->user->group->column("ID"),$core->kit->data);

foreach ($sharing as $kit_ID => $sharings) {
	if (in_array($ID, (array) $sharings))
		continue;
	unset($sharing[$kit_ID]);
}

$sharing = array_keys($sharing);

$usergroups = $core->user->group->read_column("name",["exclude"=>$core->user->data("group_ID")]);

$form = $core->form();

$form->config("checkbox_separator","<br>");

$form->new_elements(
	array(
		"name" => array(
	  	"label"			=> "Name",
	  	"value"			=> ifttt(key_of("title",$kit_config) !== key_of("name",$entry), key_of("name",$entry)),
			"disabled"  => $core->user->is_dev() ? false : true,
			"placeholder" => $core->language->translate(key_of("title",$kit_config)),
		),
		"unique_name" => array(
		  "label"			=> "Kit-Tag",
		  "value"			=> $entry["unique_name"],
			"disabled"  => true,
		),
		"folder" 			=> array(
		  "label"			=> "Path",
		  "value"			=> $entry["folder"],
			"disabled"  => true,
		),
		"group_ID" 		=> array(
		  "label"			=> "Menu",
		  "type"			=> "select",
		  "value"			=> $entry["group_ID"],
		  "values"			=> $core->kit->data->group->read_column("name"),
			"disabled"  => $core->user->is_dev() ? false : true,
		),
		"position" 		=> array(
		  "label"			=> "Position",
		  "type"			=> "select",
		  "values"			=> $position,
			"disabled"  => $core->user->is_dev() ? false : true,
		),
		"sharing" 		=> array(
		  "label"			=> "Sharing",
		  "type"			=> "checkbox",
		  "value"			=> $sharing,
		  "values"			=> $usergroups,
			"class"			=> "dropdown",
		),
		"save" => array(
		  "type"			=> "submit",
		  "value"			=> "Save",
		  "class"			=> "green",
		)
	)
);

if ($form->submit()) {

  $update = array(
    "ID"			=> $ID,
    // "name"			=> either($form->value("name"),key_of("name",$entry), key_of("title",$kit_config)),
    "name"			=> either($form->value("name"), key_of("title",$kit_config)),
    "group_ID"	=> either($form->value("group_ID"),$entry["group_ID"]),
    "position"	=> either($form->value("position"),$entry["position"]),
  );

  $core->message->set(
		$core->user->is_dev() ?
		$kit_o->update($update) :
		$core->kit->data->update($update)
	);
  $core->correlation->user_groups_have($core->kit->data->db_table(),$form->value("sharing"),$ID,$core->user->group->read_children($core->user->data("group_ID")));
	$core->message->info();
	$core->refresh(array("ID"=>$ID));

}

echo $core->template->kit->panel(
	"Edit",
	$form->render(false),
	$form->field("save").'<a class="cancel button" href="'.$core->generate_url(array("do"=>"","ID"=>"")).'">Close</a>',
	array("wrap_form"=>true,"footer"=>array("class"=>"fill flex"))
);
