<?php

	if(isset($store_kits[$core->get("ID")]))
		$kit_info = $store_kits[$core->get("ID")];

	else if(isset($private_kits[$core->get("ID")]))
		$kit_info = $private_kits[$core->get("ID")];

	else $kit_info = array();

	$version_local = $local(key_of("name", $kit_info));

	if (is_empty($version_local))
		$version_local = $local_release(key_of("name", $kit_info));

	$remarks = $core->array->range_by(key_fetch("remarks_all",$kit_info),true,$version_local);
	unset($remarks[$version_local]);

	$release_notes = array();

	if(not_empty($remarks))
	foreach($remarks as $version => $remark){
		$release_notes[] = array(
			$core->html->tag("h4", "Version ".$version),
			markdown_decode($remark, ["shift"=>1])
		);
	}

	$release_notes = $core->html->render($core->html->article($release_notes));

	$table = $core->html->table(
		array(
			array($core->language->translate("Vendor"),fetch("owner",$kit_info)),
			array($core->language->translate("Local version"),either($version_local, "-")),
			array($core->language->translate("Remote version"),fetch("version",$kit_info)),
			array($core->language->translate("Published"),kb_date("d.m.Y",fetch("updated",$kit_info))),
		),
		false,
		array("class"=>"form")
	);

	$tabs = array(
		"Description" => array(
			$core->html->article(markdown_decode(key_of("description",$kit_info), array("shift"=>1))),
			$table
		),
	);

	if ((bool)$version_local)
		$tabs["Version"] = $release_notes;


	echo $core->template->kit->panel(
		$core->html->tag("h3", fetch("display_name",$kit_info), array("class"=>"section")),
		$core->template->kit->tabs($tabs),
		array(
			$core->html->tag("a",either(ifttt($version_local == key_of("version",$kit_info), "Redownload"), ifttt($version_local > 0,"Update"), "Download"), array("class"=>"green button","href"=>$core->generate_url(array("do"=>"download")))),
			$core->html->tag("a","Close", array("class"=>"cancel button","href"=>$core->generate_url(array("do"=>"","ID"=>"")))),
		),
		array(
			"footer" => array("class" => "fill flex")
		)
	);
